1# SPDX-License-Identifier: GPL-2.0+
2
3VERSION = 2021
4PATCHLEVEL = 04
5SUBLEVEL =
6EXTRAVERSION =
7NAME =
8
9# *DOCUMENTATION*
10# To see a list of typical targets execute "make help"
11# More info can be located in ./README
12# Comments in this file are targeted only to the developer, do not
13# expect to learn how to build the kernel reading this file.
14
15# o Do not use make's built-in rules and variables
16#   (this increases performance and avoids hard-to-debug behaviour);
17# o Look for make include files relative to root of kernel src
18MAKEFLAGS += -rR --include-dir=$(CURDIR)
19
20# Determine host architecture
21include include/host_arch.h
22MK_ARCH="${shell uname -m}"
23unexport HOST_ARCH
24ifeq ("x86_64", $(MK_ARCH))
25  export HOST_ARCH=$(HOST_ARCH_X86_64)
26else ifneq (,$(findstring $(MK_ARCH), "i386" "i486" "i586" "i686"))
27  export HOST_ARCH=$(HOST_ARCH_X86)
28else ifneq (,$(findstring $(MK_ARCH), "aarch64" "armv8l"))
29  export HOST_ARCH=$(HOST_ARCH_AARCH64)
30else ifeq ("armv7l", $(MK_ARCH))
31  export HOST_ARCH=$(HOST_ARCH_ARM)
32else ifeq ("riscv32", $(MK_ARCH))
33  export HOST_ARCH=$(HOST_ARCH_RISCV32)
34else ifeq ("riscv64", $(MK_ARCH))
35  export HOST_ARCH=$(HOST_ARCH_RISCV64)
36endif
37undefine MK_ARCH
38
39# Avoid funny character set dependencies
40unexport LC_ALL
41LC_COLLATE=C
42LC_NUMERIC=C
43export LC_COLLATE LC_NUMERIC
44
45# Avoid interference with shell env settings
46unexport GREP_OPTIONS
47
48# We are using a recursive build, so we need to do a little thinking
49# to get the ordering right.
50#
51# Most importantly: sub-Makefiles should only ever modify files in
52# their own directory. If in some directory we have a dependency on
53# a file in another dir (which doesn't happen often, but it's often
54# unavoidable when linking the built-in.o targets which finally
55# turn into vmlinux), we will call a sub make in that other dir, and
56# after that we are sure that everything which is in that other dir
57# is now up to date.
58#
59# The only cases where we need to modify files which have global
60# effects are thus separated out and done before the recursive
61# descending is started. They are now explicitly listed as the
62# prepare rule.
63
64# Beautify output
65# ---------------------------------------------------------------------------
66#
67# Normally, we echo the whole command before executing it. By making
68# that echo $($(quiet)$(cmd)), we now have the possibility to set
69# $(quiet) to choose other forms of output instead, e.g.
70#
71#         quiet_cmd_cc_o_c = Compiling $(RELDIR)/$@
72#         cmd_cc_o_c       = $(CC) $(c_flags) -c -o $@ $<
73#
74# If $(quiet) is empty, the whole command will be printed.
75# If it is set to "quiet_", only the short version will be printed.
76# If it is set to "silent_", nothing will be printed at all, since
77# the variable $(silent_cmd_cc_o_c) doesn't exist.
78#
79# A simple variant is to prefix commands with $(Q) - that's useful
80# for commands that shall be hidden in non-verbose mode.
81#
82#	$(Q)ln $@ :<
83#
84# If KBUILD_VERBOSE equals 0 then the above command will be hidden.
85# If KBUILD_VERBOSE equals 1 then the above command is displayed.
86#
87# To put more focus on warnings, be less verbose as default
88# Use 'make V=1' to see the full commands
89
90ifeq ("$(origin V)", "command line")
91  KBUILD_VERBOSE = $(V)
92endif
93ifndef KBUILD_VERBOSE
94  KBUILD_VERBOSE = 0
95endif
96
97ifeq ($(KBUILD_VERBOSE),1)
98  quiet =
99  Q =
100else
101  quiet=quiet_
102  Q = @
103endif
104
105# If the user is running make -s (silent mode), suppress echoing of
106# commands
107
108ifneq ($(filter 4.%,$(MAKE_VERSION)),)	# make-4
109ifneq ($(filter %s ,$(firstword x$(MAKEFLAGS))),)
110  quiet=silent_
111endif
112else					# make-3.8x
113ifneq ($(filter s% -s%,$(MAKEFLAGS)),)
114  quiet=silent_
115endif
116endif
117
118export quiet Q KBUILD_VERBOSE
119
120# kbuild supports saving output files in a separate directory.
121# To locate output files in a separate directory two syntaxes are supported.
122# In both cases the working directory must be the root of the kernel src.
123# 1) O=
124# Use "make O=dir/to/store/output/files/"
125#
126# 2) Set KBUILD_OUTPUT
127# Set the environment variable KBUILD_OUTPUT to point to the directory
128# where the output files shall be placed.
129# export KBUILD_OUTPUT=dir/to/store/output/files/
130# make
131#
132# The O= assignment takes precedence over the KBUILD_OUTPUT environment
133# variable.
134
135# KBUILD_SRC is set on invocation of make in OBJ directory
136# KBUILD_SRC is not intended to be used by the regular user (for now)
137ifeq ($(KBUILD_SRC),)
138
139# OK, Make called in directory where kernel src resides
140# Do we want to locate output files in a separate directory?
141ifeq ("$(origin O)", "command line")
142  KBUILD_OUTPUT := $(O)
143endif
144
145# That's our default target when none is given on the command line
146PHONY := _all
147_all:
148
149# Cancel implicit rules on top Makefile
150$(CURDIR)/Makefile Makefile: ;
151
152ifneq ($(KBUILD_OUTPUT),)
153# Invoke a second make in the output directory, passing relevant variables
154# check that the output directory actually exists
155saved-output := $(KBUILD_OUTPUT)
156KBUILD_OUTPUT := $(shell mkdir -p $(KBUILD_OUTPUT) && cd $(KBUILD_OUTPUT) \
157								&& /bin/pwd)
158$(if $(KBUILD_OUTPUT),, \
159     $(error failed to create output directory "$(saved-output)"))
160
161PHONY += $(MAKECMDGOALS) sub-make
162
163$(filter-out _all sub-make $(CURDIR)/Makefile, $(MAKECMDGOALS)) _all: sub-make
164	@:
165
166sub-make: FORCE
167	$(Q)$(MAKE) -C $(KBUILD_OUTPUT) KBUILD_SRC=$(CURDIR) \
168	-f $(CURDIR)/Makefile $(filter-out _all sub-make,$(MAKECMDGOALS))
169
170# Leave processing to above invocation of make
171skip-makefile := 1
172endif # ifneq ($(KBUILD_OUTPUT),)
173endif # ifeq ($(KBUILD_SRC),)
174
175# We process the rest of the Makefile if this is the final invocation of make
176ifeq ($(skip-makefile),)
177
178# Do not print "Entering directory ...",
179# but we want to display it when entering to the output directory
180# so that IDEs/editors are able to understand relative filenames.
181MAKEFLAGS += --no-print-directory
182
183# Call a source code checker (by default, "sparse") as part of the
184# C compilation.
185#
186# Use 'make C=1' to enable checking of only re-compiled files.
187# Use 'make C=2' to enable checking of *all* source files, regardless
188# of whether they are re-compiled or not.
189#
190# See the file "doc/sparse.txt" for more details, including
191# where to get the "sparse" utility.
192
193ifeq ("$(origin C)", "command line")
194  KBUILD_CHECKSRC = $(C)
195endif
196ifndef KBUILD_CHECKSRC
197  KBUILD_CHECKSRC = 0
198endif
199
200# Use make M=dir to specify directory of external module to build
201# Old syntax make ... SUBDIRS=$PWD is still supported
202# Setting the environment variable KBUILD_EXTMOD take precedence
203ifdef SUBDIRS
204  KBUILD_EXTMOD ?= $(SUBDIRS)
205endif
206
207ifeq ("$(origin M)", "command line")
208  KBUILD_EXTMOD := $(M)
209endif
210
211# If building an external module we do not care about the all: rule
212# but instead _all depend on modules
213PHONY += all
214ifeq ($(KBUILD_EXTMOD),)
215_all: all
216else
217_all: modules
218endif
219
220ifeq ($(KBUILD_SRC),)
221        # building in the source tree
222        srctree := .
223else
224        ifeq ($(KBUILD_SRC)/,$(dir $(CURDIR)))
225                # building in a subdirectory of the source tree
226                srctree := ..
227        else
228                srctree := $(KBUILD_SRC)
229        endif
230endif
231objtree		:= .
232src		:= $(srctree)
233obj		:= $(objtree)
234
235VPATH		:= $(srctree)$(if $(KBUILD_EXTMOD),:$(KBUILD_EXTMOD))
236
237export srctree objtree VPATH
238
239# Make sure CDPATH settings don't interfere
240unexport CDPATH
241
242#########################################################################
243
244HOSTARCH := $(shell uname -m | \
245	sed -e s/i.86/x86/ \
246	    -e s/sun4u/sparc64/ \
247	    -e s/arm.*/arm/ \
248	    -e s/sa110/arm/ \
249	    -e s/ppc64/powerpc/ \
250	    -e s/ppc/powerpc/ \
251	    -e s/macppc/powerpc/\
252	    -e s/sh.*/sh/)
253
254HOSTOS := $(shell uname -s | tr '[:upper:]' '[:lower:]' | \
255	    sed -e 's/\(cygwin\).*/cygwin/')
256
257export	HOSTARCH HOSTOS
258
259#########################################################################
260
261# set default to nothing for native builds
262ifeq ($(HOSTARCH),$(ARCH))
263CROSS_COMPILE ?=
264endif
265
266KCONFIG_CONFIG	?= .config
267export KCONFIG_CONFIG
268
269# SHELL used by kbuild
270CONFIG_SHELL := $(shell if [ -x "$$BASH" ]; then echo $$BASH; \
271	  else if [ -x /bin/bash ]; then echo /bin/bash; \
272	  else echo sh; fi ; fi)
273
274HOST_LFS_CFLAGS := $(shell getconf LFS_CFLAGS 2>/dev/null)
275HOST_LFS_LDFLAGS := $(shell getconf LFS_LDFLAGS 2>/dev/null)
276HOST_LFS_LIBS := $(shell getconf LFS_LIBS 2>/dev/null)
277
278HOSTCC       = cc
279HOSTCXX      = c++
280KBUILD_HOSTCFLAGS   := -Wall -Wstrict-prototypes -O2 -fomit-frame-pointer \
281		$(HOST_LFS_CFLAGS) $(HOSTCFLAGS)
282KBUILD_HOSTCXXFLAGS := -O2 $(HOST_LFS_CFLAGS) $(HOSTCXXFLAGS)
283KBUILD_HOSTLDFLAGS  := $(HOST_LFS_LDFLAGS) $(HOSTLDFLAGS)
284KBUILD_HOSTLDLIBS   := $(HOST_LFS_LIBS) $(HOSTLDLIBS)
285
286# With the move to GCC 6, we have implicitly upgraded our language
287# standard to GNU11 (see https://gcc.gnu.org/gcc-5/porting_to.html).
288# Some Linux distributions (including RHEL7, SLES13, Debian 8) still
289# have older compilers as their default, so we make it explicit for
290# these that our host tools are GNU11 (i.e. C11 w/ GNU extensions).
291CSTD_FLAG := -std=gnu11
292ifeq ($(HOSTOS),linux)
293KBUILD_HOSTCFLAGS += $(CSTD_FLAG)
294endif
295
296ifeq ($(HOSTOS),cygwin)
297KBUILD_HOSTCFLAGS	+= -ansi
298endif
299
300# Mac OS X / Darwin's C preprocessor is Apple specific.  It
301# generates numerous errors and warnings.  We want to bypass it
302# and use GNU C's cpp.	To do this we pass the -traditional-cpp
303# option to the compiler.  Note that the -traditional-cpp flag
304# DOES NOT have the same semantics as GNU C's flag, all it does
305# is invoke the GNU preprocessor in stock ANSI/ISO C fashion.
306#
307# Apple's linker is similar, thanks to the new 2 stage linking
308# multiple symbol definitions are treated as errors, hence the
309# -multiply_defined suppress option to turn off this error.
310#
311ifeq ($(HOSTOS),darwin)
312# get major and minor product version (e.g. '10' and '6' for Snow Leopard)
313DARWIN_MAJOR_VERSION	= $(shell sw_vers -productVersion | cut -f 1 -d '.')
314DARWIN_MINOR_VERSION	= $(shell sw_vers -productVersion | cut -f 2 -d '.')
315
316os_x_before	= $(shell if [ $(DARWIN_MAJOR_VERSION) -le $(1) -a \
317	$(DARWIN_MINOR_VERSION) -le $(2) ] ; then echo "$(3)"; else echo "$(4)"; fi ;)
318
319os_x_after = $(shell if [ $(DARWIN_MAJOR_VERSION) -ge $(1) -a \
320	$(DARWIN_MINOR_VERSION) -ge $(2) ] ; then echo "$(3)"; else echo "$(4)"; fi ;)
321
322# Snow Leopards build environment has no longer restrictions as described above
323HOSTCC       = $(call os_x_before, 10, 5, "cc", "gcc")
324KBUILD_HOSTCFLAGS  += $(call os_x_before, 10, 4, "-traditional-cpp")
325KBUILD_HOSTLDFLAGS += $(call os_x_before, 10, 5, "-multiply_defined suppress")
326
327# macOS Mojave (10.14.X)
328# Undefined symbols for architecture x86_64: "_PyArg_ParseTuple"
329KBUILD_HOSTLDFLAGS += $(call os_x_after, 10, 14, "-lpython -dynamclib", "")
330endif
331
332# Decide whether to build built-in, modular, or both.
333# Normally, just do built-in.
334
335KBUILD_MODULES :=
336KBUILD_BUILTIN := 1
337
338# If we have only "make modules", don't compile built-in objects.
339# When we're building modules with modversions, we need to consider
340# the built-in objects during the descend as well, in order to
341# make sure the checksums are up to date before we record them.
342
343ifeq ($(MAKECMDGOALS),modules)
344  KBUILD_BUILTIN := $(if $(CONFIG_MODVERSIONS),1)
345endif
346
347# If we have "make <whatever> modules", compile modules
348# in addition to whatever we do anyway.
349# Just "make" or "make all" shall build modules as well
350
351# U-Boot does not need modules
352#ifneq ($(filter all _all modules,$(MAKECMDGOALS)),)
353#  KBUILD_MODULES := 1
354#endif
355
356#ifeq ($(MAKECMDGOALS),)
357#  KBUILD_MODULES := 1
358#endif
359
360# Check ths size of a binary:
361# Args:
362#   $1: File to check
363#   #2: Size limit in bytes (decimal or 0xhex)
364define size_check
365	actual=$$( wc -c $1 | awk '{print $$1}'); \
366	limit=$$( printf "%d" $2 ); \
367	if test $$actual -gt $$limit; then \
368		echo "$1 exceeds file size limit:" >&2; \
369		echo "  limit:  $$(printf %#x $$limit) bytes" >&2; \
370		echo "  actual: $$(printf %#x $$actual) bytes" >&2; \
371		echo "  excess: $$(printf %#x $$((actual - limit))) bytes" >&2;\
372		exit 1; \
373	fi
374endef
375export size_check
376
377export KBUILD_MODULES KBUILD_BUILTIN
378export KBUILD_CHECKSRC KBUILD_SRC KBUILD_EXTMOD
379
380# We need some generic definitions (do not try to remake the file).
381scripts/Kbuild.include: ;
382include scripts/Kbuild.include
383
384# Make variables (CC, etc...)
385
386AS		= $(CROSS_COMPILE)as
387# Always use GNU ld
388ifneq ($(shell $(CROSS_COMPILE)ld.bfd -v 2> /dev/null),)
389LD		= $(CROSS_COMPILE)ld.bfd
390else
391LD		= $(CROSS_COMPILE)ld
392endif
393CC		= $(CROSS_COMPILE)gcc
394CPP		= $(CC) -E
395AR		= $(CROSS_COMPILE)ar
396NM		= $(CROSS_COMPILE)nm
397LDR		= $(CROSS_COMPILE)ldr
398STRIP		= $(CROSS_COMPILE)strip
399OBJCOPY		= $(CROSS_COMPILE)objcopy
400OBJDUMP		= $(CROSS_COMPILE)objdump
401LEX		= flex
402YACC		= bison
403AWK		= awk
404PERL		= perl
405PYTHON		?= python
406PYTHON2		= python2
407PYTHON3		= python3
408DTC		?= $(objtree)/scripts/dtc/dtc
409CHECK		= sparse
410
411CHECKFLAGS     := -D__linux__ -Dlinux -D__STDC__ -Dunix -D__unix__ \
412		  -Wbitwise -Wno-return-void -D__CHECK_ENDIAN__ $(CF)
413
414KBUILD_CPPFLAGS := -D__KERNEL__ -D__UBOOT__
415
416KBUILD_CFLAGS   := -Wall -Wstrict-prototypes \
417		   -Wno-format-security \
418		   -fno-builtin -ffreestanding $(CSTD_FLAG)
419KBUILD_CFLAGS	+= -fshort-wchar -fno-strict-aliasing
420KBUILD_AFLAGS   := -D__ASSEMBLY__
421KBUILD_LDFLAGS  :=
422
423ifeq ($(cc-name),clang)
424ifneq ($(CROSS_COMPILE),)
425CLANG_TARGET	:= --target=$(notdir $(CROSS_COMPILE:%-=%))
426GCC_TOOLCHAIN_DIR := $(dir $(shell which $(LD)))
427CLANG_PREFIX	:= --prefix=$(GCC_TOOLCHAIN_DIR)
428GCC_TOOLCHAIN	:= $(realpath $(GCC_TOOLCHAIN_DIR)/..)
429endif
430ifneq ($(GCC_TOOLCHAIN),)
431CLANG_GCC_TC	:= --gcc-toolchain=$(GCC_TOOLCHAIN)
432endif
433KBUILD_CFLAGS += $(CLANG_TARGET) $(CLANG_GCC_TC) $(CLANG_PREFIX)
434KBUILD_AFLAGS += $(CLANG_TARGET) $(CLANG_GCC_TC) $(CLANG_PREFIX)
435KBUILD_CFLAGS += $(call cc-option, -no-integrated-as)
436KBUILD_AFLAGS += $(call cc-option, -no-integrated-as)
437endif
438
439# Don't generate position independent code
440KBUILD_CFLAGS	+= $(call cc-option,-fno-PIE)
441KBUILD_AFLAGS	+= $(call cc-option,-fno-PIE)
442
443# Read UBOOTRELEASE from include/config/uboot.release (if it exists)
444UBOOTRELEASE = $(shell cat include/config/uboot.release 2> /dev/null)
445UBOOTVERSION = $(VERSION)$(if $(PATCHLEVEL),.$(PATCHLEVEL)$(if $(SUBLEVEL),.$(SUBLEVEL)))$(EXTRAVERSION)
446
447export VERSION PATCHLEVEL SUBLEVEL UBOOTRELEASE UBOOTVERSION
448export ARCH CPU BOARD VENDOR SOC CPUDIR BOARDDIR
449export CONFIG_SHELL HOSTCC KBUILD_HOSTCFLAGS CROSS_COMPILE AS LD CC
450export CPP AR NM LDR STRIP OBJCOPY OBJDUMP KBUILD_HOSTLDFLAGS KBUILD_HOSTLDLIBS
451export MAKE LEX YACC AWK PERL PYTHON PYTHON2 PYTHON3
452export HOSTCXX KBUILD_HOSTCXXFLAGS CHECK CHECKFLAGS DTC DTC_FLAGS
453
454export KBUILD_CPPFLAGS NOSTDINC_FLAGS UBOOTINCLUDE OBJCOPYFLAGS KBUILD_LDFLAGS
455export KBUILD_CFLAGS KBUILD_AFLAGS
456
457export CC_VERSION_TEXT := $(shell $(CC) --version | head -n 1)
458
459# When compiling out-of-tree modules, put MODVERDIR in the module
460# tree rather than in the kernel tree. The kernel tree might
461# even be read-only.
462export MODVERDIR := $(if $(KBUILD_EXTMOD),$(firstword $(KBUILD_EXTMOD))/).tmp_versions
463
464# Files to ignore in find ... statements
465
466export RCS_FIND_IGNORE := \( -name SCCS -o -name BitKeeper -o -name .svn -o    \
467			  -name CVS -o -name .pc -o -name .hg -o -name .git \) \
468			  -prune -o
469export RCS_TAR_IGNORE := --exclude SCCS --exclude BitKeeper --exclude .svn \
470			 --exclude CVS --exclude .pc --exclude .hg --exclude .git
471
472# ===========================================================================
473# Rules shared between *config targets and build targets
474
475# Basic helpers built in scripts/
476PHONY += scripts_basic
477scripts_basic:
478	$(Q)$(MAKE) $(build)=scripts/basic
479	$(Q)rm -f .tmp_quiet_recordmcount
480
481# To avoid any implicit rule to kick in, define an empty command.
482scripts/basic/%: scripts_basic ;
483
484PHONY += outputmakefile
485# outputmakefile generates a Makefile in the output directory, if using a
486# separate output directory. This allows convenient use of make in the
487# output directory.
488outputmakefile:
489ifneq ($(KBUILD_SRC),)
490	$(Q)ln -fsn $(srctree) source
491	$(Q)$(CONFIG_SHELL) $(srctree)/scripts/mkmakefile \
492	    $(srctree) $(objtree) $(VERSION) $(PATCHLEVEL)
493endif
494
495# To make sure we do not include .config for any of the *config targets
496# catch them early, and hand them over to scripts/kconfig/Makefile
497# It is allowed to specify more targets when calling make, including
498# mixing *config targets and build targets.
499# For example 'make oldconfig all'.
500# Detect when mixed targets is specified, and make a second invocation
501# of make so .config is not included in this case either (for *config).
502
503version_h := include/generated/version_autogenerated.h
504timestamp_h := include/generated/timestamp_autogenerated.h
505defaultenv_h := include/generated/defaultenv_autogenerated.h
506dt_h := include/generated/dt.h
507
508no-dot-config-targets := clean clobber mrproper distclean \
509			 help %docs check% coccicheck \
510			 ubootversion backup tests check qcheck tcheck
511
512config-targets := 0
513mixed-targets  := 0
514dot-config     := 1
515
516ifneq ($(filter $(no-dot-config-targets), $(MAKECMDGOALS)),)
517	ifeq ($(filter-out $(no-dot-config-targets), $(MAKECMDGOALS)),)
518		dot-config := 0
519	endif
520endif
521
522ifeq ($(KBUILD_EXTMOD),)
523        ifneq ($(filter config %config,$(MAKECMDGOALS)),)
524                config-targets := 1
525                ifneq ($(words $(MAKECMDGOALS)),1)
526                        mixed-targets := 1
527                endif
528        endif
529endif
530
531ifeq ($(mixed-targets),1)
532# ===========================================================================
533# We're called with mixed targets (*config and build targets).
534# Handle them one by one.
535
536PHONY += $(MAKECMDGOALS) __build_one_by_one
537
538$(filter-out __build_one_by_one, $(MAKECMDGOALS)): __build_one_by_one
539	@:
540
541__build_one_by_one:
542	$(Q)set -e; \
543	for i in $(MAKECMDGOALS); do \
544		$(MAKE) -f $(srctree)/Makefile $$i; \
545	done
546
547else
548ifeq ($(config-targets),1)
549# ===========================================================================
550# *config targets only - make sure prerequisites are updated, and descend
551# in scripts/kconfig to make the *config target
552
553KBUILD_DEFCONFIG := sandbox_defconfig
554export KBUILD_DEFCONFIG KBUILD_KCONFIG
555
556config: scripts_basic outputmakefile FORCE
557	$(Q)$(MAKE) $(build)=scripts/kconfig $@
558
559%config: scripts_basic outputmakefile FORCE
560	$(Q)$(MAKE) $(build)=scripts/kconfig $@
561
562else
563# ===========================================================================
564# Build targets only - this includes vmlinux, arch specific targets, clean
565# targets and others. In general all targets except *config targets.
566
567# Additional helpers built in scripts/
568# Carefully list dependencies so we do not try to build scripts twice
569# in parallel
570PHONY += scripts
571scripts: scripts_basic include/config/auto.conf
572	$(Q)$(MAKE) $(build)=$(@)
573
574ifeq ($(dot-config),1)
575# Read in config
576-include include/config/auto.conf
577
578# Read in dependencies to all Kconfig* files, make sure to run
579# oldconfig if changes are detected.
580-include include/config/auto.conf.cmd
581
582# To avoid any implicit rule to kick in, define an empty command
583$(KCONFIG_CONFIG) include/config/auto.conf.cmd: ;
584
585# If .config is newer than include/config/auto.conf, someone tinkered
586# with it and forgot to run make oldconfig.
587# if auto.conf.cmd is missing then we are probably in a cleaned tree so
588# we execute the config step to be sure to catch updated Kconfig files
589include/config/%.conf: $(KCONFIG_CONFIG) include/config/auto.conf.cmd
590	$(Q)$(MAKE) -f $(srctree)/Makefile syncconfig
591	@# If the following part fails, include/config/auto.conf should be
592	@# deleted so "make silentoldconfig" will be re-run on the next build.
593	$(Q)$(MAKE) -f $(srctree)/scripts/Makefile.autoconf || \
594		{ rm -f include/config/auto.conf; false; }
595	@# include/config.h has been updated after "make silentoldconfig".
596	@# We need to touch include/config/auto.conf so it gets newer
597	@# than include/config.h.
598	@# Otherwise, 'make silentoldconfig' would be invoked twice.
599	$(Q)touch include/config/auto.conf
600
601u-boot.cfg spl/u-boot.cfg tpl/u-boot.cfg:
602	$(Q)$(MAKE) -f $(srctree)/scripts/Makefile.autoconf $(@)
603
604-include include/autoconf.mk
605-include include/autoconf.mk.dep
606
607# We want to include arch/$(ARCH)/config.mk only when include/config/auto.conf
608# is up-to-date. When we switch to a different board configuration, old CONFIG
609# macros are still remaining in include/config/auto.conf. Without the following
610# gimmick, wrong config.mk would be included leading nasty warnings/errors.
611ifneq ($(wildcard $(KCONFIG_CONFIG)),)
612ifneq ($(wildcard include/config/auto.conf),)
613autoconf_is_old := $(shell find . -path ./$(KCONFIG_CONFIG) -newer \
614						include/config/auto.conf)
615ifeq ($(autoconf_is_old),)
616include config.mk
617include arch/$(ARCH)/Makefile
618endif
619endif
620endif
621
622# These are set by the arch-specific config.mk. Make sure they are exported
623# so they can be used when building an EFI application.
624export EFI_LDS		# Filename of EFI link script in arch/$(ARCH)/lib
625export EFI_CRT0		# Filename of EFI CRT0 in arch/$(ARCH)/lib
626export EFI_RELOC	# Filename of EFU relocation code in arch/$(ARCH)/lib
627export CFLAGS_EFI	# Compiler flags to add when building EFI app
628export CFLAGS_NON_EFI	# Compiler flags to remove when building EFI app
629export EFI_TARGET	# binutils target if EFI is natively supported
630
631# If board code explicitly specified LDSCRIPT or CONFIG_SYS_LDSCRIPT, use
632# that (or fail if absent).  Otherwise, search for a linker script in a
633# standard location.
634
635ifndef LDSCRIPT
636	#LDSCRIPT := $(srctree)/board/$(BOARDDIR)/u-boot.lds.debug
637	ifdef CONFIG_SYS_LDSCRIPT
638		# need to strip off double quotes
639		LDSCRIPT := $(srctree)/$(CONFIG_SYS_LDSCRIPT:"%"=%)
640	endif
641endif
642
643# If there is no specified link script, we look in a number of places for it
644ifndef LDSCRIPT
645	ifeq ($(wildcard $(LDSCRIPT)),)
646		LDSCRIPT := $(srctree)/board/$(BOARDDIR)/u-boot.lds
647	endif
648	ifeq ($(wildcard $(LDSCRIPT)),)
649		LDSCRIPT := $(srctree)/$(CPUDIR)/u-boot.lds
650	endif
651	ifeq ($(wildcard $(LDSCRIPT)),)
652		LDSCRIPT := $(srctree)/arch/$(ARCH)/cpu/u-boot.lds
653	endif
654endif
655
656else
657# Dummy target needed, because used as prerequisite
658include/config/auto.conf: ;
659endif # $(dot-config)
660
661#
662# Xtensa linker script cannot be preprocessed with -ansi because of
663# preprocessor operations on strings that don't make C identifiers.
664#
665ifeq ($(CONFIG_XTENSA),)
666LDPPFLAGS	+= -ansi
667endif
668
669ifdef CONFIG_CC_OPTIMIZE_FOR_SIZE
670KBUILD_CFLAGS	+= -Os
671else
672KBUILD_CFLAGS	+= -O2
673endif
674
675KBUILD_CFLAGS += $(call cc-option,-fno-stack-protector)
676KBUILD_CFLAGS += $(call cc-option,-fno-delete-null-pointer-checks)
677
678# disable stringop warnings in gcc 8+
679KBUILD_CFLAGS += $(call cc-disable-warning, stringop-truncation)
680
681# Enabled with W=2, disabled by default as noisy
682KBUILD_CFLAGS += $(call cc-disable-warning, maybe-uninitialized)
683
684# change __FILE__ to the relative path from the srctree
685KBUILD_CFLAGS	+= $(call cc-option,-fmacro-prefix-map=$(srctree)/=)
686
687KBUILD_CFLAGS	+= -g
688# $(KBUILD_AFLAGS) sets -g, which causes gcc to pass a suitable -g<format>
689# option to the assembler.
690KBUILD_AFLAGS	+= -g
691
692# Report stack usage if supported
693# ARC tools based on GCC 7.1 has an issue with stack usage
694# with naked functions, see commit message for more details
695ifndef CONFIG_ARC
696ifeq ($(shell $(CONFIG_SHELL) $(srctree)/scripts/gcc-stack-usage.sh $(CC)),y)
697	KBUILD_CFLAGS += -fstack-usage
698endif
699endif
700
701KBUILD_CFLAGS += $(call cc-option,-Wno-format-nonliteral)
702KBUILD_CFLAGS += $(call cc-disable-warning, address-of-packed-member)
703
704ifeq ($(cc-name),clang)
705KBUILD_CPPFLAGS += $(call cc-option,-Qunused-arguments,)
706KBUILD_CFLAGS += $(call cc-disable-warning, format-invalid-specifier)
707KBUILD_CFLAGS += $(call cc-disable-warning, gnu)
708KBUILD_CFLAGS += $(call cc-disable-warning, address-of-packed-member)
709# Quiet clang warning: comparison of unsigned expression < 0 is always false
710KBUILD_CFLAGS += $(call cc-disable-warning, tautological-compare)
711# CLANG uses a _MergedGlobals as optimization, but this breaks modpost, as the
712# source of a reference will be _MergedGlobals and not on of the whitelisted names.
713# See modpost pattern 2
714KBUILD_CFLAGS += $(call cc-option, -mno-global-merge,)
715KBUILD_CFLAGS += $(call cc-option, -fcatch-undefined-behavior)
716else
717
718# These warnings generated too much noise in a regular build.
719# Use make W=1 to enable them (see scripts/Makefile.extrawarn)
720KBUILD_CFLAGS += $(call cc-disable-warning, unused-but-set-variable)
721endif
722
723# Prohibit date/time macros, which would make the build non-deterministic
724KBUILD_CFLAGS   += $(call cc-option,-Werror=date-time)
725
726include scripts/Makefile.extrawarn
727
728# Add user supplied CPPFLAGS, AFLAGS and CFLAGS as the last assignments
729KBUILD_CPPFLAGS += $(KCPPFLAGS)
730KBUILD_AFLAGS += $(KAFLAGS)
731KBUILD_CFLAGS += $(KCFLAGS)
732
733KBUILD_HOSTCFLAGS += $(if $(CONFIG_TOOLS_DEBUG),-g)
734
735# Use UBOOTINCLUDE when you must reference the include/ directory.
736# Needed to be compatible with the O= option
737UBOOTINCLUDE    := \
738	-Iinclude \
739	$(if $(KBUILD_SRC), -I$(srctree)/include) \
740	$(if $(CONFIG_$(SPL_)SYS_THUMB_BUILD), \
741		$(if $(CONFIG_HAS_THUMB2), \
742			$(if $(CONFIG_CPU_V7M), \
743				-I$(srctree)/arch/arm/thumb1/include), \
744			-I$(srctree)/arch/arm/thumb1/include)) \
745	-I$(srctree)/arch/$(ARCH)/include \
746	-include $(srctree)/include/linux/kconfig.h
747
748NOSTDINC_FLAGS += -nostdinc -isystem $(shell $(CC) -print-file-name=include)
749
750# FIX ME
751cpp_flags := $(KBUILD_CPPFLAGS) $(PLATFORM_CPPFLAGS) $(UBOOTINCLUDE) \
752							$(NOSTDINC_FLAGS)
753c_flags := $(KBUILD_CFLAGS) $(cpp_flags)
754
755#########################################################################
756# U-Boot objects....order is important (i.e. start must be first)
757
758HAVE_VENDOR_COMMON_LIB = $(if $(wildcard $(srctree)/board/$(VENDOR)/common/Makefile),y,n)
759
760libs-y += lib/
761libs-$(HAVE_VENDOR_COMMON_LIB) += board/$(VENDOR)/common/
762libs-$(CONFIG_OF_EMBED) += dts/
763libs-y += fs/
764libs-y += net/
765libs-y += disk/
766libs-y += drivers/
767libs-y += drivers/dma/
768libs-y += drivers/gpio/
769libs-y += drivers/i2c/
770libs-y += drivers/net/
771libs-y += drivers/net/phy/
772libs-y += drivers/power/ \
773	drivers/power/domain/ \
774	drivers/power/fuel_gauge/ \
775	drivers/power/mfd/ \
776	drivers/power/pmic/ \
777	drivers/power/battery/ \
778	drivers/power/regulator/
779libs-y += drivers/spi/
780libs-$(CONFIG_FMAN_ENET) += drivers/net/fm/
781libs-$(CONFIG_SYS_FSL_DDR) += drivers/ddr/fsl/
782libs-$(CONFIG_SYS_FSL_MMDC) += drivers/ddr/fsl/
783libs-$(CONFIG_$(SPL_)ALTERA_SDRAM) += drivers/ddr/altera/
784libs-y += drivers/serial/
785libs-y += drivers/usb/cdns3/
786libs-y += drivers/usb/dwc3/
787libs-y += drivers/usb/common/
788libs-y += drivers/usb/emul/
789libs-y += drivers/usb/eth/
790libs-$(CONFIG_USB_DEVICE) += drivers/usb/gadget/
791libs-$(CONFIG_USB_GADGET) += drivers/usb/gadget/
792libs-$(CONFIG_USB_GADGET) += drivers/usb/gadget/udc/
793libs-y += drivers/usb/host/
794libs-y += drivers/usb/mtu3/
795libs-y += drivers/usb/musb/
796libs-y += drivers/usb/musb-new/
797libs-y += drivers/usb/phy/
798libs-y += drivers/usb/ulpi/
799libs-y += cmd/
800libs-y += common/
801libs-y += env/
802libs-$(CONFIG_API) += api/
803ifdef CONFIG_POST
804libs-y += post/
805endif
806libs-$(CONFIG_UNIT_TEST) += test/
807libs-$(CONFIG_UT_ENV) += test/env/
808libs-$(CONFIG_UT_OPTEE) += test/optee/
809libs-$(CONFIG_UT_OVERLAY) += test/overlay/
810
811libs-y += $(if $(BOARDDIR),board/$(BOARDDIR)/)
812
813libs-y := $(sort $(libs-y))
814
815u-boot-dirs	:= $(patsubst %/,%,$(filter %/, $(libs-y))) tools examples
816
817u-boot-alldirs	:= $(sort $(u-boot-dirs) $(patsubst %/,%,$(filter %/, $(libs-))))
818
819libs-y		:= $(patsubst %/, %/built-in.o, $(libs-y))
820
821u-boot-init := $(head-y)
822u-boot-main := $(libs-y)
823
824
825# Add GCC lib
826ifeq ($(CONFIG_USE_PRIVATE_LIBGCC),y)
827PLATFORM_LIBGCC = arch/$(ARCH)/lib/lib.a
828else
829PLATFORM_LIBGCC := -L $(shell dirname `$(CC) $(c_flags) -print-libgcc-file-name`) -lgcc
830endif
831PLATFORM_LIBS += $(PLATFORM_LIBGCC)
832
833ifdef CONFIG_CC_COVERAGE
834KBUILD_CFLAGS += --coverage
835PLATFORM_LIBGCC += -lgcov
836endif
837
838export PLATFORM_LIBS
839export PLATFORM_LIBGCC
840
841# Special flags for CPP when processing the linker script.
842# Pass the version down so we can handle backwards compatibility
843# on the fly.
844LDPPFLAGS += \
845	-include $(srctree)/include/u-boot/u-boot.lds.h \
846	-DCPUDIR=$(CPUDIR) \
847	$(shell $(LD) --version | \
848	  sed -ne 's/GNU ld version \([0-9][0-9]*\)\.\([0-9][0-9]*\).*/-DLD_MAJOR=\1 -DLD_MINOR=\2/p')
849
850#########################################################################
851#########################################################################
852
853ifneq ($(CONFIG_BOARD_SIZE_LIMIT),)
854BOARD_SIZE_CHECK= @ $(call size_check,$@,$(CONFIG_BOARD_SIZE_LIMIT))
855else
856BOARD_SIZE_CHECK =
857endif
858
859ifneq ($(CONFIG_SPL_SIZE_LIMIT),0x0)
860SPL_SIZE_CHECK = @$(call size_check,$@,$$(tools/spl_size_limit))
861else
862SPL_SIZE_CHECK =
863endif
864
865ifneq ($(CONFIG_TPL_SIZE_LIMIT),0x0)
866TPL_SIZE_CHECK = @$(call size_check,$@,$(CONFIG_TPL_SIZE_LIMIT))
867else
868TPL_SIZE_CHECK =
869endif
870
871# Statically apply RELA-style relocations (currently arm64 only)
872# This is useful for arm64 where static relocation needs to be performed on
873# the raw binary, but certain simulators only accept an ELF file (but don't
874# do the relocation).
875ifneq ($(CONFIG_STATIC_RELA),)
876# $(1) is u-boot ELF, $(2) is u-boot bin, $(3) is text base
877quiet_cmd_static_rela = RELOC   $@
878cmd_static_rela = \
879	start=$$($(NM) $(2) | grep __rel_dyn_start | cut -f 1 -d ' '); \
880	end=$$($(NM) $(2) | grep __rel_dyn_end | cut -f 1 -d ' '); \
881	tools/relocate-rela $(3) $(4) $$start $$end
882else
883quiet_cmd_static_rela =
884cmd_static_rela =
885endif
886
887# Always append INPUTS so that arch config.mk's can add custom ones
888INPUTS-y += u-boot.srec u-boot.bin u-boot.sym System.map binary_size_check
889
890INPUTS-$(CONFIG_ONENAND_U_BOOT) += u-boot-onenand.bin
891ifeq ($(CONFIG_SPL_FSL_PBL),y)
892INPUTS-$(CONFIG_RAMBOOT_PBL) += u-boot-with-spl-pbl.bin
893else
894ifneq ($(CONFIG_NXP_ESBC), y)
895# For Secure Boot The Image needs to be signed and Header must also
896# be included. So The image has to be built explicitly
897INPUTS-$(CONFIG_RAMBOOT_PBL) += u-boot.pbl
898endif
899endif
900INPUTS-$(CONFIG_SPL) += spl/u-boot-spl.bin
901ifeq ($(CONFIG_MX6)$(CONFIG_IMX_HAB), yy)
902INPUTS-$(CONFIG_SPL_FRAMEWORK) += u-boot-ivt.img
903else
904ifeq ($(CONFIG_MX7)$(CONFIG_IMX_HAB), yy)
905INPUTS-$(CONFIG_SPL_FRAMEWORK) += u-boot-ivt.img
906else
907INPUTS-$(CONFIG_SPL_FRAMEWORK) += u-boot.img
908endif
909endif
910INPUTS-$(CONFIG_TPL) += tpl/u-boot-tpl.bin
911INPUTS-$(CONFIG_OF_SEPARATE) += u-boot.dtb
912ifeq ($(CONFIG_SPL_FRAMEWORK),y)
913INPUTS-$(CONFIG_OF_SEPARATE) += u-boot-dtb.img
914endif
915INPUTS-$(CONFIG_OF_HOSTFILE) += u-boot.dtb
916ifneq ($(CONFIG_SPL_TARGET),)
917INPUTS-$(CONFIG_SPL) += $(CONFIG_SPL_TARGET:"%"=%)
918endif
919INPUTS-$(CONFIG_REMAKE_ELF) += u-boot.elf
920INPUTS-$(CONFIG_EFI_APP) += u-boot-app.efi
921INPUTS-$(CONFIG_EFI_STUB) += u-boot-payload.efi
922
923# Generate this input file for binman
924ifeq ($(CONFIG_SPL),)
925INPUTS-$(CONFIG_ARCH_MEDIATEK) += u-boot-mtk.bin
926endif
927
928# Add optional build target if defined in board/cpu/soc headers
929ifneq ($(CONFIG_BUILD_TARGET),)
930INPUTS-y += $(CONFIG_BUILD_TARGET:"%"=%)
931endif
932
933ifeq ($(CONFIG_INIT_SP_RELATIVE)$(CONFIG_OF_SEPARATE),yy)
934INPUTS-y += init_sp_bss_offset_check
935endif
936
937ifeq ($(CONFIG_MPC85xx)$(CONFIG_OF_SEPARATE),yy)
938INPUTS-y += u-boot-with-dtb.bin
939endif
940
941ifeq ($(CONFIG_ARCH_ROCKCHIP),y)
942# On ARM64 this target is produced by binman so we don't need this dep
943ifeq ($(CONFIG_ARM64),y)
944ifeq ($(CONFIG_SPL),y)
945# TODO: Get binman to generate this too
946INPUTS-y += u-boot-rockchip.bin
947endif
948else
949ifeq ($(CONFIG_SPL),y)
950# Generate these inputs for binman which will create the output files
951INPUTS-y += idbloader.img u-boot.img
952endif
953endif
954endif
955
956INPUTS-$(CONFIG_X86) += u-boot-x86-start16.bin u-boot-x86-reset16.bin \
957	$(if $(CONFIG_SPL_X86_16BIT_INIT),spl/u-boot-spl.bin) \
958	$(if $(CONFIG_TPL_X86_16BIT_INIT),tpl/u-boot-tpl.bin)
959
960LDFLAGS_u-boot += $(LDFLAGS_FINAL)
961
962# Avoid 'Not enough room for program headers' error on binutils 2.28 onwards.
963LDFLAGS_u-boot += $(call ld-option, --no-dynamic-linker)
964
965ifeq ($(CONFIG_ARC)$(CONFIG_NIOS2)$(CONFIG_X86)$(CONFIG_XTENSA),)
966LDFLAGS_u-boot += -Ttext $(CONFIG_SYS_TEXT_BASE)
967endif
968
969# insure the checker run with the right endianness
970CHECKFLAGS += $(if $(CONFIG_CPU_BIG_ENDIAN),-mbig-endian,-mlittle-endian)
971
972# the checker needs the correct machine size
973CHECKFLAGS += $(if $(CONFIG_64BIT),-m64,-m32)
974
975# Normally we fill empty space with 0xff
976quiet_cmd_objcopy = OBJCOPY $@
977cmd_objcopy = $(OBJCOPY) --gap-fill=0xff $(OBJCOPYFLAGS) \
978	$(OBJCOPYFLAGS_$(@F)) $< $@
979
980# Provide a version which does not do this, for use by EFI
981quiet_cmd_zobjcopy = OBJCOPY $@
982cmd_zobjcopy = $(OBJCOPY) $(OBJCOPYFLAGS) $(OBJCOPYFLAGS_$(@F)) $< $@
983
984quiet_cmd_efipayload = OBJCOPY $@
985cmd_efipayload = $(OBJCOPY) -I binary -O $(EFIPAYLOAD_BFDTARGET) -B $(EFIPAYLOAD_BFDARCH) $< $@
986
987MKIMAGEOUTPUT ?= /dev/null
988
989quiet_cmd_mkimage = MKIMAGE $@
990cmd_mkimage = $(objtree)/tools/mkimage $(MKIMAGEFLAGS_$(@F)) -d $< $@ \
991	>$(MKIMAGEOUTPUT) $(if $(KBUILD_VERBOSE:0=), && cat $(MKIMAGEOUTPUT))
992
993quiet_cmd_mkfitimage = MKIMAGE $@
994cmd_mkfitimage = $(objtree)/tools/mkimage $(MKIMAGEFLAGS_$(@F)) \
995	-f $(U_BOOT_ITS) -p $(CONFIG_FIT_EXTERNAL_OFFSET) $@ \
996	>$(MKIMAGEOUTPUT) $(if $(KBUILD_VERBOSE:0=), && cat $(MKIMAGEOUTPUT))
997
998quiet_cmd_cat = CAT     $@
999cmd_cat = cat $(filter-out $(PHONY), $^) > $@
1000
1001append = cat $(filter-out $< $(PHONY), $^) >> $@
1002
1003quiet_cmd_pad_cat = CAT     $@
1004cmd_pad_cat = $(cmd_objcopy) && $(append) || { rm -f $@; false; }
1005
1006quiet_cmd_lzma = LZMA    $@
1007cmd_lzma = lzma -c -z -k -9 $< > $@
1008
1009cfg: u-boot.cfg
1010
1011quiet_cmd_cfgcheck = CFGCHK  $2
1012cmd_cfgcheck = $(srctree)/scripts/check-config.sh $2 \
1013		$(srctree)/scripts/config_whitelist.txt $(srctree)
1014
1015# Concat the value of all the CONFIGs (result is 'y' or 'yy', etc. )
1016got = $(foreach cfg,$(1),$($(cfg)))
1017
1018# expected value 'y for each one
1019expect = $(foreach cfg,$(1),y)
1020
1021# Show a deprecation message
1022# Args:
1023# 1: List of CONFIG_DM_... to migrate to (e.g. "CONFIG_DM_MMC CONFIG_BLK")
1024# 2: Name of component (e.g . "Ethernet drivers")
1025# 3: Release deadline (e.g. "v202.07")
1026# 4: Condition to require before checking (e.g. "$(CONFIG_NET)")
1027# Note: Script avoids bash construct, hence the strange double 'if'
1028# (patches welcome!)
1029define deprecated
1030	@if [ -n "$(strip $(4))" ]; then if [ "$(got)" != "$(expect)" ]; then \
1031		echo >&2 "===================== WARNING ======================"; \
1032		echo >&2 "This board does not use $(firstword $(1)) (Driver Model"; \
1033		echo >&2 "for $(2)). Please update the board to use"; \
1034		echo >&2 "$(firstword $(1)) before the $(3) release. Failure to"; \
1035		echo >&2 "update by the deadline may result in board removal."; \
1036		echo >&2 "See doc/driver-model/migration.rst for more info."; \
1037		echo >&2 "===================================================="; \
1038	fi; fi
1039
1040endef
1041
1042PHONY += inputs
1043inputs: $(INPUTS-y)
1044
1045all: .binman_stamp inputs
1046ifeq ($(CONFIG_BINMAN),y)
1047	$(call if_changed,binman)
1048endif
1049
1050# Timestamp file to make sure that binman always runs
1051.binman_stamp: FORCE
1052	@touch $@
1053
1054ifeq ($(CONFIG_DEPRECATED),y)
1055	$(warning "You have deprecated configuration options enabled in your .config! Please check your configuration.")
1056endif
1057ifeq ($(CONFIG_OF_EMBED),y)
1058	@echo >&2 "===================== WARNING ======================"
1059	@echo >&2 "CONFIG_OF_EMBED is enabled. This option should only"
1060	@echo >&2 "be used for debugging purposes. Please use"
1061	@echo >&2 "CONFIG_OF_SEPARATE for boards in mainline."
1062	@echo >&2 "See doc/README.fdt-control for more info."
1063	@echo >&2 "===================================================="
1064endif
1065ifneq ($(CONFIG_SPL_FIT_GENERATOR),)
1066	@echo >&2 "===================== WARNING ======================"
1067	@echo >&2 "This board uses CONFIG_SPL_FIT_GENERATOR. Please migrate"
1068	@echo >&2 "to binman instead, to avoid the proliferation of"
1069	@echo >&2 "arch-specific scripts with no tests."
1070	@echo >&2 "===================================================="
1071endif
1072ifneq ($(CONFIG_DM),y)
1073	@echo >&2 "===================== WARNING ======================"
1074	@echo >&2 "This board does not use CONFIG_DM. CONFIG_DM will be"
1075	@echo >&2 "compulsory starting with the v2020.01 release."
1076	@echo >&2 "Failure to update may result in board removal."
1077	@echo >&2 "See doc/driver-model/migration.rst for more info."
1078	@echo >&2 "===================================================="
1079endif
1080	$(call deprecated,CONFIG_DM_MMC CONFIG_BLK,MMC,v2019.04,$(CONFIG_MMC))
1081	$(call deprecated,CONFIG_DM_USB CONFIG_OF_CONTROL CONFIG_BLK,\
1082		USB,v2019.07,$(CONFIG_USB))
1083	$(call deprecated,CONFIG_AHCI,AHCI instead of CONFIG_MVSATA_IDE,v2019.07, \
1084		$(CONFIG_MVSATA_IDE))
1085	$(call deprecated,CONFIG_AHCI,AHCI,v2019.07, $(CONFIG_LIBATA))
1086	$(call deprecated,CONFIG_DM_PCI,PCI,v2019.07,$(CONFIG_PCI))
1087	$(call deprecated,CONFIG_DM_VIDEO,video,v2019.07,\
1088		$(CONFIG_LCD)$(CONFIG_VIDEO))
1089	$(call deprecated,CONFIG_DM_SPI_FLASH,SPI flash,v2019.07,\
1090		$(CONFIG_SPI_FLASH))
1091	$(call deprecated,CONFIG_WDT,DM watchdog,v2019.10,\
1092		$(CONFIG_WATCHDOG)$(CONFIG_HW_WATCHDOG))
1093	$(call deprecated,CONFIG_DM_ETH,Ethernet drivers,v2020.07,$(CONFIG_NET))
1094	$(call deprecated,CONFIG_DM_I2C,I2C drivers,v2022.04,$(CONFIG_I2C))
1095	@# Check that this build does not use CONFIG options that we do not
1096	@# know about unless they are in Kconfig. All the existing CONFIG
1097	@# options are whitelisted, so new ones should not be added.
1098	$(call cmd,cfgcheck,u-boot.cfg)
1099
1100PHONY += dtbs
1101dtbs: dts/dt.dtb
1102	@:
1103dts/dt.dtb: u-boot
1104	$(Q)$(MAKE) $(build)=dts dtbs
1105
1106quiet_cmd_copy = COPY    $@
1107      cmd_copy = cp $< $@
1108
1109ifeq ($(CONFIG_MULTI_DTB_FIT),y)
1110
1111ifeq ($(CONFIG_MULTI_DTB_FIT_LZO),y)
1112FINAL_DTB_CONTAINER = fit-dtb.blob.lzo
1113else ifeq ($(CONFIG_MULTI_DTB_FIT_GZIP),y)
1114FINAL_DTB_CONTAINER = fit-dtb.blob.gz
1115else
1116FINAL_DTB_CONTAINER = fit-dtb.blob
1117endif
1118
1119fit-dtb.blob.gz: fit-dtb.blob
1120	@gzip -kf9 $< > $@
1121
1122fit-dtb.blob.lzo: fit-dtb.blob
1123	@lzop -f9 $< > $@
1124
1125fit-dtb.blob: dts/dt.dtb FORCE
1126	$(call if_changed,mkimage)
1127ifneq ($(SOURCE_DATE_EPOCH),)
1128	touch -d @$(SOURCE_DATE_EPOCH) fit-dtb.blob
1129	chmod 0600 fit-dtb.blob
1130endif
1131
1132MKIMAGEFLAGS_fit-dtb.blob = -f auto -A $(ARCH) -T firmware -C none -O u-boot \
1133	-a 0 -e 0 -E \
1134	$(patsubst %,-b arch/$(ARCH)/dts/%.dtb,$(subst ",,$(CONFIG_OF_LIST))) -d /dev/null
1135
1136ifneq ($(EXT_DTB),)
1137u-boot-fit-dtb.bin: u-boot-nodtb.bin $(EXT_DTB)
1138		$(call if_changed,cat)
1139else
1140u-boot-fit-dtb.bin: u-boot-nodtb.bin $(FINAL_DTB_CONTAINER)
1141	$(call if_changed,cat)
1142endif
1143
1144u-boot.bin: u-boot-fit-dtb.bin FORCE
1145	$(call if_changed,copy)
1146
1147u-boot-dtb.bin: u-boot-nodtb.bin dts/dt.dtb FORCE
1148	$(call if_changed,cat)
1149
1150else ifeq ($(CONFIG_OF_SEPARATE),y)
1151u-boot-dtb.bin: u-boot-nodtb.bin dts/dt.dtb FORCE
1152	$(call if_changed,cat)
1153
1154u-boot.bin: u-boot-dtb.bin FORCE
1155	$(call if_changed,copy)
1156else
1157u-boot.bin: u-boot-nodtb.bin FORCE
1158	$(call if_changed,copy)
1159endif
1160
1161# we call Makefile in arch/arm/mach-imx which
1162# has targets which are dependent on targets defined
1163# here. make could not resolve them and we must ensure
1164# that they are finished before calling imx targets
1165ifeq ($(CONFIG_MULTI_DTB_FIT),y)
1166IMX_DEPS = u-boot-fit-dtb.bin
1167endif
1168
1169%.imx: $(IMX_DEPS) %.bin
1170	$(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1171	$(BOARD_SIZE_CHECK)
1172
1173%.vyb: %.imx
1174	$(Q)$(MAKE) $(build)=arch/arm/cpu/armv7/vf610 $@
1175
1176quiet_cmd_copy = COPY    $@
1177      cmd_copy = cp $< $@
1178
1179u-boot.dtb: dts/dt.dtb
1180	$(call cmd,copy)
1181
1182OBJCOPYFLAGS_u-boot.hex := -O ihex
1183
1184OBJCOPYFLAGS_u-boot.srec := -O srec
1185
1186u-boot.hex u-boot.srec: u-boot FORCE
1187	$(call if_changed,objcopy)
1188
1189OBJCOPYFLAGS_u-boot-elf.srec := $(OBJCOPYFLAGS_u-boot.srec)
1190
1191u-boot-elf.srec: u-boot.elf FORCE
1192	$(call if_changed,objcopy)
1193
1194OBJCOPYFLAGS_u-boot-spl.srec = $(OBJCOPYFLAGS_u-boot.srec)
1195
1196spl/u-boot-spl.srec: spl/u-boot-spl FORCE
1197	$(call if_changed,objcopy)
1198
1199%.scif: %.srec
1200	$(Q)$(MAKE) $(build)=arch/arm/mach-rmobile $@
1201
1202OBJCOPYFLAGS_u-boot-nodtb.bin := -O binary \
1203		$(if $(CONFIG_X86_16BIT_INIT),-R .start16 -R .resetvec) \
1204		$(if $(CONFIG_MPC85XX_HAVE_RESET_VECTOR),-R .bootpg -R .resetvec)
1205
1206binary_size_check: u-boot-nodtb.bin FORCE
1207	@file_size=$(shell wc -c u-boot-nodtb.bin | awk '{print $$1}') ; \
1208	map_size=$(shell cat u-boot.map | \
1209		awk '/_image_copy_start/ {start = $$1} /_image_binary_end/ {end = $$1} END {if (start != "" && end != "") print "ibase=16; " toupper(end) " - " toupper(start)}' \
1210		| sed 's/0X//g' \
1211		| bc); \
1212	if [ "" != "$$map_size" ]; then \
1213		if test $$map_size -ne $$file_size; then \
1214			echo "u-boot.map shows a binary size of $$map_size" >&2 ; \
1215			echo "  but u-boot-nodtb.bin shows $$file_size" >&2 ; \
1216			exit 1; \
1217		fi \
1218	fi
1219
1220ifeq ($(CONFIG_INIT_SP_RELATIVE)$(CONFIG_OF_SEPARATE),yy)
1221ifneq ($(CONFIG_SYS_MALLOC_F_LEN),)
1222subtract_sys_malloc_f_len = space=$$(($${space} - $(CONFIG_SYS_MALLOC_F_LEN)))
1223else
1224subtract_sys_malloc_f_len = true
1225endif
1226# The 1/4 margin below is somewhat arbitrary. The likely initial SP usage is
1227# so low that the DTB could probably use 90%+ of the available space, for
1228# current values of CONFIG_SYS_INIT_SP_BSS_OFFSET at least. However, let's be
1229# safe for now and tweak this later if space becomes tight.
1230# A rejected alternative would be to check that some absolute minimum stack
1231# space was available. However, since CONFIG_SYS_INIT_SP_BSS_OFFSET is
1232# deliberately build-specific, to take account of build-to-build stack usage
1233# differences due to different feature sets, there is no common absolute value
1234# to check against.
1235init_sp_bss_offset_check: u-boot.dtb FORCE
1236	@dtb_size=$(shell wc -c u-boot.dtb | awk '{print $$1}') ; \
1237	space=$(CONFIG_SYS_INIT_SP_BSS_OFFSET) ; \
1238	$(subtract_sys_malloc_f_len) ; \
1239	quarter_space=$$(($${space} / 4)) ; \
1240	if [ $${dtb_size} -gt $${quarter_space} ]; then \
1241		echo "u-boot.dtb is larger than 1 quarter of " >&2 ; \
1242		echo "(CONFIG_SYS_INIT_SP_BSS_OFFSET - CONFIG_SYS_MALLOC_F_LEN)" >&2 ; \
1243		exit 1 ; \
1244	fi
1245endif
1246
1247shell_cmd = { $(call echo-cmd,$(1)) $(cmd_$(1)); }
1248
1249quiet_cmd_objcopy_uboot = OBJCOPY $@
1250ifdef cmd_static_rela
1251cmd_objcopy_uboot = $(cmd_objcopy) && $(call shell_cmd,static_rela,$<,$@,$(CONFIG_SYS_TEXT_BASE)) || { rm -f $@; false; }
1252else
1253cmd_objcopy_uboot = $(cmd_objcopy)
1254endif
1255
1256u-boot-nodtb.bin: u-boot FORCE
1257	$(call if_changed,objcopy_uboot)
1258	$(BOARD_SIZE_CHECK)
1259
1260u-boot.ldr:	u-boot
1261		$(CREATE_LDR_ENV)
1262		$(LDR) -T $(CONFIG_CPU) -c $@ $< $(LDR_FLAGS)
1263		$(BOARD_SIZE_CHECK)
1264
1265# binman
1266# ---------------------------------------------------------------------------
1267# Use 'make BINMAN_DEBUG=1' to enable debugging
1268default_dt := $(if $(DEVICE_TREE),$(DEVICE_TREE),$(CONFIG_DEFAULT_DEVICE_TREE))
1269quiet_cmd_binman = BINMAN  $@
1270cmd_binman = $(srctree)/tools/binman/binman $(if $(BINMAN_DEBUG),-D) \
1271                --toolpath $(objtree)/tools \
1272		$(if $(BINMAN_VERBOSE),-v$(BINMAN_VERBOSE)) \
1273		build -u -d u-boot.dtb -O . -m --allow-missing \
1274		-I . -I $(srctree) -I $(srctree)/board/$(BOARDDIR) \
1275		-I arch/$(ARCH)/dts -a of-list=$(CONFIG_OF_LIST) \
1276		-a atf-bl31-path=${BL31} \
1277		-a default-dt=$(default_dt) \
1278		-a scp-path=$(SCP) \
1279		$(BINMAN_$(@F))
1280
1281OBJCOPYFLAGS_u-boot.ldr.hex := -I binary -O ihex
1282
1283OBJCOPYFLAGS_u-boot.ldr.srec := -I binary -O srec
1284
1285u-boot.ldr.hex u-boot.ldr.srec: u-boot.ldr FORCE
1286	$(call if_changed,objcopy)
1287
1288#
1289# U-Boot entry point, needed for booting of full-blown U-Boot
1290# from the SPL U-Boot version.
1291#
1292ifndef CONFIG_SYS_UBOOT_START
1293CONFIG_SYS_UBOOT_START := $(CONFIG_SYS_TEXT_BASE)
1294endif
1295
1296# Boards with more complex image requirements can provide an .its source file
1297# or a generator script
1298# NOTE: Please do not use this. We are migrating away from Makefile rules to use
1299# binman instead.
1300ifneq ($(CONFIG_SPL_FIT_SOURCE),"")
1301U_BOOT_ITS := u-boot.its
1302$(U_BOOT_ITS): $(subst ",,$(CONFIG_SPL_FIT_SOURCE))
1303	$(call if_changed,copy)
1304else
1305ifneq ($(CONFIG_USE_SPL_FIT_GENERATOR),)
1306U_BOOT_ITS := u-boot.its
1307ifeq ($(CONFIG_SPL_FIT_GENERATOR),"arch/arm/mach-imx/mkimage_fit_atf.sh")
1308U_BOOT_ITS_DEPS += u-boot-nodtb.bin
1309endif
1310ifeq ($(CONFIG_SPL_FIT_GENERATOR),"arch/arm/mach-rockchip/make_fit_atf.py")
1311U_BOOT_ITS_DEPS += u-boot
1312endif
1313$(U_BOOT_ITS): $(U_BOOT_ITS_DEPS) FORCE
1314	$(srctree)/$(CONFIG_SPL_FIT_GENERATOR) \
1315	$(patsubst %,arch/$(ARCH)/dts/%.dtb,$(subst ",,$(CONFIG_OF_LIST))) > $@
1316endif
1317endif
1318
1319ifdef CONFIG_SPL_LOAD_FIT
1320MKIMAGEFLAGS_u-boot.img = -f auto -A $(ARCH) -T firmware -C none -O u-boot \
1321	-a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
1322	-p $(CONFIG_FIT_EXTERNAL_OFFSET) \
1323	-n "U-Boot $(UBOOTRELEASE) for $(BOARD) board" -E \
1324	$(patsubst %,-b arch/$(ARCH)/dts/%.dtb,$(subst ",,$(DEVICE_TREE))) \
1325	$(patsubst %,-b arch/$(ARCH)/dts/%.dtb,$(subst ",,$(CONFIG_OF_LIST))) \
1326	$(patsubst %,-b arch/$(ARCH)/dts/%.dtbo,$(subst ",,$(CONFIG_OF_OVERLAY_LIST)))
1327else
1328MKIMAGEFLAGS_u-boot.img = -A $(ARCH) -T firmware -C none -O u-boot \
1329	-a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
1330	-n "U-Boot $(UBOOTRELEASE) for $(BOARD) board"
1331MKIMAGEFLAGS_u-boot-ivt.img = -A $(ARCH) -T firmware_ivt -C none -O u-boot \
1332	-a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
1333	-n "U-Boot $(UBOOTRELEASE) for $(BOARD) board"
1334u-boot-ivt.img: MKIMAGEOUTPUT = u-boot-ivt.img.log
1335endif
1336
1337MKIMAGEFLAGS_u-boot-dtb.img = $(MKIMAGEFLAGS_u-boot.img)
1338
1339# Some boards have the kwbimage.cfg file written in advance, while some
1340# other boards generate it on the fly during the build in the build tree.
1341# Let's check if the file exists in the build tree first, otherwise we
1342# fall back to use the one in the source tree.
1343KWD_CONFIG_FILE = $(shell \
1344	if [ -f $(objtree)/$(CONFIG_SYS_KWD_CONFIG:"%"=%) ]; then \
1345		echo -n $(objtree)/$(CONFIG_SYS_KWD_CONFIG:"%"=%); \
1346	else \
1347		echo -n $(srctree)/$(CONFIG_SYS_KWD_CONFIG:"%"=%); \
1348	fi)
1349
1350MKIMAGEFLAGS_u-boot.kwb = -n $(KWD_CONFIG_FILE) \
1351	-T kwbimage -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_TEXT_BASE)
1352
1353MKIMAGEFLAGS_u-boot-spl.kwb = -n $(KWD_CONFIG_FILE) \
1354	-T kwbimage -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_TEXT_BASE) \
1355	$(if $(KEYDIR),-k $(KEYDIR))
1356
1357MKIMAGEFLAGS_u-boot.pbl = -n $(srctree)/$(CONFIG_SYS_FSL_PBL_RCW:"%"=%) \
1358		-R $(srctree)/$(CONFIG_SYS_FSL_PBL_PBI:"%"=%) -T pblimage
1359
1360ifeq ($(CONFIG_MPC85xx)$(CONFIG_OF_SEPARATE),yy)
1361UBOOT_BIN := u-boot-with-dtb.bin
1362else
1363UBOOT_BIN := u-boot.bin
1364endif
1365
1366MKIMAGEFLAGS_u-boot-lzma.img = -A $(ARCH) -T standalone -C lzma -O u-boot \
1367	-a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
1368	-n "U-Boot $(UBOOTRELEASE) for $(BOARD) board"
1369
1370u-boot.bin.lzma: u-boot.bin FORCE
1371	$(call if_changed,lzma)
1372
1373u-boot-lzma.img: u-boot.bin.lzma FORCE
1374	$(call if_changed,mkimage)
1375
1376u-boot-dtb.img u-boot.img u-boot.kwb u-boot.pbl u-boot-ivt.img: \
1377		$(if $(CONFIG_SPL_LOAD_FIT),u-boot-nodtb.bin \
1378			$(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_OF_HOSTFILE),dts/dt.dtb) \
1379		,$(UBOOT_BIN)) FORCE
1380	$(call if_changed,mkimage)
1381	$(BOARD_SIZE_CHECK)
1382
1383ifeq ($(CONFIG_SPL_LOAD_FIT_FULL),y)
1384MKIMAGEFLAGS_u-boot.itb =
1385else
1386MKIMAGEFLAGS_u-boot.itb = -E
1387endif
1388
1389ifdef U_BOOT_ITS
1390u-boot.itb: u-boot-nodtb.bin \
1391		$(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_OF_HOSTFILE),dts/dt.dtb) \
1392		$(U_BOOT_ITS) FORCE
1393	$(call if_changed,mkfitimage)
1394	$(BOARD_SIZE_CHECK)
1395endif
1396
1397u-boot-spl.kwb: u-boot.img spl/u-boot-spl.bin FORCE
1398	$(call if_changed,mkimage)
1399
1400u-boot.sha1:	u-boot.bin
1401		tools/ubsha1 u-boot.bin
1402
1403u-boot.dis:	u-boot
1404		$(OBJDUMP) -d $< > $@
1405
1406ifneq ($(CONFIG_SPL_PAYLOAD),)
1407SPL_PAYLOAD := $(CONFIG_SPL_PAYLOAD:"%"=%)
1408else
1409SPL_PAYLOAD := u-boot.bin
1410endif
1411
1412SPL_IMAGE := $(CONFIG_SPL_IMAGE:"%"=%)
1413
1414OBJCOPYFLAGS_u-boot-with-spl.bin = -I binary -O binary \
1415				   --pad-to=$(CONFIG_SPL_PAD_TO)
1416u-boot-with-spl.bin: $(SPL_IMAGE) $(SPL_PAYLOAD) FORCE
1417	$(call if_changed,pad_cat)
1418
1419ifeq ($(CONFIG_ARCH_ROCKCHIP),y)
1420
1421# TPL + SPL
1422ifeq ($(CONFIG_SPL)$(CONFIG_TPL),yy)
1423MKIMAGEFLAGS_u-boot-tpl-rockchip.bin = -n $(CONFIG_SYS_SOC) -T rksd
1424tpl/u-boot-tpl-rockchip.bin: tpl/u-boot-tpl.bin FORCE
1425	$(call if_changed,mkimage)
1426idbloader.img: tpl/u-boot-tpl-rockchip.bin spl/u-boot-spl.bin FORCE
1427	$(call if_changed,cat)
1428else
1429MKIMAGEFLAGS_idbloader.img = -n $(CONFIG_SYS_SOC) -T rksd
1430idbloader.img: spl/u-boot-spl.bin FORCE
1431	$(call if_changed,mkimage)
1432endif
1433
1434ifeq ($(CONFIG_ARM64),y)
1435OBJCOPYFLAGS_u-boot-rockchip.bin = -I binary -O binary \
1436	--pad-to=$(CONFIG_SPL_PAD_TO) --gap-fill=0xff
1437u-boot-rockchip.bin: idbloader.img u-boot.itb FORCE
1438	$(call if_changed,pad_cat)
1439endif # CONFIG_ARM64
1440
1441endif # CONFIG_ARCH_ROCKCHIP
1442
1443ifeq ($(CONFIG_ARCH_LPC32XX)$(CONFIG_SPL),yy)
1444MKIMAGEFLAGS_lpc32xx-spl.img = -T lpc32xximage -a $(CONFIG_SPL_TEXT_BASE)
1445
1446lpc32xx-spl.img: spl/u-boot-spl.bin FORCE
1447	$(call if_changed,mkimage)
1448
1449OBJCOPYFLAGS_lpc32xx-boot-0.bin = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO)
1450
1451lpc32xx-boot-0.bin: lpc32xx-spl.img FORCE
1452	$(call if_changed,objcopy)
1453
1454OBJCOPYFLAGS_lpc32xx-boot-1.bin = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO)
1455
1456lpc32xx-boot-1.bin: lpc32xx-spl.img FORCE
1457	$(call if_changed,objcopy)
1458
1459lpc32xx-full.bin: lpc32xx-boot-0.bin lpc32xx-boot-1.bin u-boot.img FORCE
1460	$(call if_changed,cat)
1461
1462endif
1463
1464OBJCOPYFLAGS_u-boot-with-tpl.bin = -I binary -O binary \
1465				   --pad-to=$(CONFIG_TPL_PAD_TO)
1466tpl/u-boot-with-tpl.bin: tpl/u-boot-tpl.bin u-boot.bin FORCE
1467	$(call if_changed,pad_cat)
1468
1469SPL: spl/u-boot-spl.bin FORCE
1470	$(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1471
1472ifeq ($(CONFIG_ARCH_IMX8M)$(CONFIG_ARCH_IMX8), y)
1473ifeq ($(CONFIG_SPL_LOAD_IMX_CONTAINER), y)
1474u-boot.cnt: u-boot.bin FORCE
1475	$(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1476
1477flash.bin: spl/u-boot-spl.bin u-boot.cnt FORCE
1478	$(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1479else
1480flash.bin: spl/u-boot-spl.bin u-boot.itb FORCE
1481	$(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1482endif
1483endif
1484
1485u-boot.uim: u-boot.bin FORCE
1486	$(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1487
1488u-boot-with-spl.imx u-boot-with-nand-spl.imx: SPL $(if $(CONFIG_OF_SEPARATE),u-boot.img,u-boot.uim) FORCE
1489	$(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1490
1491MKIMAGEFLAGS_u-boot.ubl = -n $(UBL_CONFIG) -T ublimage -e $(CONFIG_SYS_TEXT_BASE)
1492
1493u-boot.ubl: u-boot-with-spl.bin FORCE
1494	$(call if_changed,mkimage)
1495
1496MKIMAGEFLAGS_u-boot-spl.ais = -s -n $(if $(CONFIG_AIS_CONFIG_FILE), \
1497	$(srctree)/$(CONFIG_AIS_CONFIG_FILE:"%"=%),"/dev/null") \
1498	-T aisimage -e $(CONFIG_SPL_TEXT_BASE)
1499spl/u-boot-spl.ais: spl/u-boot-spl.bin FORCE
1500	$(call if_changed,mkimage)
1501
1502OBJCOPYFLAGS_u-boot.ais = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO)
1503u-boot.ais: spl/u-boot-spl.ais u-boot.img FORCE
1504	$(call if_changed,pad_cat)
1505
1506u-boot-signed.sb: u-boot.bin spl/u-boot-spl.bin
1507	$(Q)$(MAKE) $(build)=arch/arm/cpu/arm926ejs/mxs u-boot-signed.sb
1508u-boot.sb: u-boot.bin spl/u-boot-spl.bin
1509	$(Q)$(MAKE) $(build)=arch/arm/cpu/arm926ejs/mxs u-boot.sb
1510
1511# On x600 (SPEAr600) U-Boot is appended to U-Boot SPL.
1512# Both images are created using mkimage (crc etc), so that the ROM
1513# bootloader can check its integrity. Padding needs to be done to the
1514# SPL image (with mkimage header) and not the binary. Otherwise the resulting image
1515# which is loaded/copied by the ROM bootloader to SRAM doesn't fit.
1516# The resulting image containing both U-Boot images is called u-boot.spr
1517MKIMAGEFLAGS_u-boot-spl.img = -A $(ARCH) -T firmware -C none \
1518	-a $(CONFIG_SPL_TEXT_BASE) -e $(CONFIG_SPL_TEXT_BASE) -n XLOADER
1519spl/u-boot-spl.img: spl/u-boot-spl.bin FORCE
1520	$(call if_changed,mkimage)
1521
1522OBJCOPYFLAGS_u-boot.spr = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO) \
1523			  --gap-fill=0xff
1524u-boot.spr: spl/u-boot-spl.img u-boot.img FORCE
1525	$(call if_changed,pad_cat)
1526
1527ifneq ($(CONFIG_ARCH_SOCFPGA),)
1528quiet_cmd_gensplx4 = GENSPLX4 $@
1529cmd_gensplx4 = $(OBJCOPY) -I binary -O binary --gap-fill=0x0		\
1530			--pad-to=$(CONFIG_SPL_PAD_TO)			\
1531			spl/u-boot-spl.sfp spl/u-boot-spl.sfp &&        \
1532		cat	spl/u-boot-spl.sfp spl/u-boot-spl.sfp		\
1533			spl/u-boot-spl.sfp spl/u-boot-spl.sfp > $@ || { rm -f $@; false; }
1534spl/u-boot-splx4.sfp: spl/u-boot-spl.sfp FORCE
1535	$(call if_changed,gensplx4)
1536
1537quiet_cmd_socboot = SOCBOOT $@
1538cmd_socboot = cat	spl/u-boot-splx4.sfp u-boot.img > $@ || { rm -f $@; false; }
1539u-boot-with-spl.sfp: spl/u-boot-splx4.sfp u-boot.img FORCE
1540	$(call if_changed,socboot)
1541
1542quiet_cmd_gensplpadx4 = GENSPLPADX4 $@
1543cmd_gensplpadx4 =  dd if=/dev/zero of=spl/u-boot-spl.pad bs=64 count=1024 ; \
1544		   cat	spl/u-boot-spl.sfp spl/u-boot-spl.pad \
1545			spl/u-boot-spl.sfp spl/u-boot-spl.pad \
1546			spl/u-boot-spl.sfp spl/u-boot-spl.pad \
1547			spl/u-boot-spl.sfp spl/u-boot-spl.pad > $@ || \
1548			{ rm -f $@ spl/u-boot-spl.pad; false; }
1549u-boot-spl-padx4.sfp: spl/u-boot-spl.sfp FORCE
1550	$(call if_changed,gensplpadx4)
1551
1552quiet_cmd_socnandboot = SOCNANDBOOT $@
1553cmd_socnandboot = cat	u-boot-spl-padx4.sfp u-boot.img > $@ || { rm -f $@; false; }
1554u-boot-with-nand-spl.sfp: u-boot-spl-padx4.sfp u-boot.img FORCE
1555	$(call if_changed,socnandboot)
1556
1557endif
1558
1559ifeq ($(CONFIG_MPC85xx)$(CONFIG_OF_SEPARATE),yy)
1560u-boot-with-dtb.bin: u-boot.bin u-boot.dtb \
1561	$(if $(CONFIG_MPC85XX_HAVE_RESET_VECTOR), u-boot-br.bin) FORCE
1562	$(call if_changed,binman)
1563
1564ifeq ($(CONFIG_MPC85XX_HAVE_RESET_VECTOR),y)
1565OBJCOPYFLAGS_u-boot-br.bin := -O binary -j .bootpg -j .resetvec
1566u-boot-br.bin: u-boot FORCE
1567	$(call if_changed,objcopy)
1568endif
1569endif
1570
1571quiet_cmd_ldr = LD      $@
1572cmd_ldr = $(LD) $(LDFLAGS_$(@F)) \
1573	       $(filter-out FORCE,$^) -o $@
1574
1575ifdef CONFIG_X86
1576OBJCOPYFLAGS_u-boot-x86-start16.bin := -O binary -j .start16
1577u-boot-x86-start16.bin: u-boot FORCE
1578	$(call if_changed,objcopy)
1579
1580OBJCOPYFLAGS_u-boot-x86-reset16.bin := -O binary -j .resetvec
1581u-boot-x86-reset16.bin: u-boot FORCE
1582	$(call if_changed,objcopy)
1583
1584endif # CONFIG_X86
1585
1586OBJCOPYFLAGS_u-boot-app.efi := $(OBJCOPYFLAGS_EFI)
1587u-boot-app.efi: u-boot FORCE
1588	$(call if_changed,zobjcopy)
1589
1590u-boot.bin.o: u-boot.bin FORCE
1591	$(call if_changed,efipayload)
1592
1593u-boot-payload.lds: $(LDSCRIPT_EFI) FORCE
1594	$(call if_changed_dep,cpp_lds)
1595
1596# Rule to link the EFI payload which contains a stub and a U-Boot binary
1597quiet_cmd_u-boot_payload ?= LD      $@
1598      cmd_u-boot_payload ?= $(LD) $(LDFLAGS_EFI_PAYLOAD) -o $@ \
1599      -T u-boot-payload.lds arch/x86/cpu/call32.o \
1600      lib/efi/efi.o lib/efi/efi_stub.o u-boot.bin.o \
1601      $(addprefix arch/$(ARCH)/lib/,$(EFISTUB))
1602
1603u-boot-payload: u-boot.bin.o u-boot-payload.lds FORCE
1604	$(call if_changed,u-boot_payload)
1605
1606OBJCOPYFLAGS_u-boot-payload.efi := $(OBJCOPYFLAGS_EFI)
1607u-boot-payload.efi: u-boot-payload FORCE
1608	$(call if_changed,zobjcopy)
1609
1610u-boot-img.bin: spl/u-boot-spl.bin u-boot.img FORCE
1611	$(call if_changed,cat)
1612
1613#Add a target to create boot binary having SPL binary in PBI format
1614#concatenated with u-boot binary. It is need by PowerPC SoC having
1615#internal SRAM <= 512KB.
1616MKIMAGEFLAGS_u-boot-spl.pbl = -n $(srctree)/$(CONFIG_SYS_FSL_PBL_RCW:"%"=%) \
1617		-R $(srctree)/$(CONFIG_SYS_FSL_PBL_PBI:"%"=%) -T pblimage \
1618		-A $(ARCH) -a $(CONFIG_SPL_TEXT_BASE)
1619
1620spl/u-boot-spl.pbl: spl/u-boot-spl.bin FORCE
1621	$(call if_changed,mkimage)
1622
1623ifeq ($(ARCH),arm)
1624UBOOT_BINLOAD := u-boot.img
1625else
1626ifeq ($(CONFIG_MPC85xx)$(CONFIG_OF_SEPARATE),yy)
1627UBOOT_BINLOAD := u-boot-with-dtb.bin
1628else
1629UBOOT_BINLOAD := u-boot.bin
1630endif
1631endif
1632
1633OBJCOPYFLAGS_u-boot-with-spl-pbl.bin = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO) \
1634			  --gap-fill=0xff
1635
1636u-boot-with-spl-pbl.bin: spl/u-boot-spl.pbl $(UBOOT_BINLOAD) FORCE
1637	$(call if_changed,pad_cat)
1638
1639# PPC4xx needs the SPL at the end of the image, since the reset vector
1640# is located at 0xfffffffc. So we can't use the "u-boot-img.bin" target
1641# and need to introduce a new build target with the full blown U-Boot
1642# at the start padded up to the start of the SPL image. And then concat
1643# the SPL image to the end.
1644
1645OBJCOPYFLAGS_u-boot-img-spl-at-end.bin := -I binary -O binary \
1646	--pad-to=$(CONFIG_UBOOT_PAD_TO) --gap-fill=0xff
1647u-boot-img-spl-at-end.bin: u-boot.img spl/u-boot-spl.bin FORCE
1648	$(call if_changed,pad_cat)
1649
1650quiet_cmd_u-boot-elf ?= LD      $@
1651	cmd_u-boot-elf ?= $(LD) u-boot-elf.o -o $@ \
1652	-T u-boot-elf.lds --defsym=$(CONFIG_PLATFORM_ELFENTRY)=$(CONFIG_SYS_TEXT_BASE) \
1653	-Ttext=$(CONFIG_SYS_TEXT_BASE)
1654u-boot.elf: u-boot.bin u-boot-elf.lds
1655	$(Q)$(OBJCOPY) -I binary $(PLATFORM_ELFFLAGS) $< u-boot-elf.o
1656	$(call if_changed,u-boot-elf)
1657
1658u-boot-elf.lds: arch/u-boot-elf.lds prepare FORCE
1659	$(call if_changed_dep,cpp_lds)
1660
1661# MediaTek's ARM-based u-boot needs a header to contains its load address
1662# which is parsed by the BootROM.
1663# If the SPL build is enabled, the header will be added to the spl binary,
1664# and the spl binary and the u-boot.img will be combined into one file.
1665# Otherwise the header will be added to the u-boot.bin directly.
1666
1667ifeq ($(CONFIG_SPL),y)
1668spl/u-boot-spl-mtk.bin: spl/u-boot-spl
1669else
1670MKIMAGEFLAGS_u-boot-mtk.bin = -T mtk_image \
1671	-a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_TEXT_BASE) \
1672	-n "$(patsubst "%",%,$(CONFIG_MTK_BROM_HEADER_INFO))"
1673
1674u-boot-mtk.bin: u-boot.bin FORCE
1675	$(call if_changed,mkimage)
1676endif
1677
1678quiet_cmd_endian_swap = SWAP    $@
1679      cmd_endian_swap = $(srctree)/tools/endian-swap.py $< $@
1680
1681u-boot-swap.bin: u-boot.bin FORCE
1682	$(call if_changed,endian_swap)
1683
1684ARCH_POSTLINK := $(wildcard $(srctree)/arch/$(ARCH)/Makefile.postlink)
1685
1686# Rule to link u-boot
1687# May be overridden by arch/$(ARCH)/config.mk
1688quiet_cmd_u-boot__ ?= LD      $@
1689      cmd_u-boot__ ?= $(LD) $(KBUILD_LDFLAGS) $(LDFLAGS_u-boot) -o $@ \
1690      -T u-boot.lds $(u-boot-init)                             \
1691      --start-group $(u-boot-main) --end-group                 \
1692      $(PLATFORM_LIBS) -Map u-boot.map;                        \
1693      $(if $(ARCH_POSTLINK), $(MAKE) -f $(ARCH_POSTLINK) $@, true)
1694
1695quiet_cmd_smap = GEN     common/system_map.o
1696cmd_smap = \
1697	smap=`$(call SYSTEM_MAP,u-boot) | \
1698		awk '$$2 ~ /[tTwW]/ {printf $$1 $$3 "\\\\000"}'` ; \
1699	$(CC) $(c_flags) -DSYSTEM_MAP="\"$${smap}\"" \
1700		-c $(srctree)/common/system_map.c -o common/system_map.o
1701
1702u-boot:	$(u-boot-init) $(u-boot-main) u-boot.lds FORCE
1703	+$(call if_changed,u-boot__)
1704ifeq ($(CONFIG_KALLSYMS),y)
1705	$(call cmd,smap)
1706	$(call cmd,u-boot__) common/system_map.o
1707endif
1708
1709ifeq ($(CONFIG_RISCV),y)
1710	@tools/prelink-riscv $@ 0
1711endif
1712
1713quiet_cmd_sym ?= SYM     $@
1714      cmd_sym ?= $(OBJDUMP) -t $< > $@
1715u-boot.sym: u-boot FORCE
1716	$(call if_changed,sym)
1717
1718# The actual objects are generated when descending,
1719# make sure no implicit rule kicks in
1720$(sort $(u-boot-init) $(u-boot-main)): $(u-boot-dirs) ;
1721
1722# Handle descending into subdirectories listed in $(u-boot-dirs)
1723# Preset locale variables to speed up the build process. Limit locale
1724# tweaks to this spot to avoid wrong language settings when running
1725# make menuconfig etc.
1726# Error messages still appears in the original language
1727
1728PHONY += $(u-boot-dirs)
1729$(u-boot-dirs): prepare scripts
1730	$(Q)$(MAKE) $(build)=$@
1731
1732tools: prepare
1733# The "tools" are needed early
1734$(filter-out tools, $(u-boot-dirs)): tools
1735# The "examples" conditionally depend on U-Boot (say, when USE_PRIVATE_LIBGCC
1736# is "yes"), so compile examples after U-Boot is compiled.
1737examples: $(filter-out examples, $(u-boot-dirs))
1738
1739define filechk_uboot.release
1740	echo "$(UBOOTVERSION)$$($(CONFIG_SHELL) $(srctree)/scripts/setlocalversion $(srctree))"
1741endef
1742
1743# Store (new) UBOOTRELEASE string in include/config/uboot.release
1744include/config/uboot.release: include/config/auto.conf FORCE
1745	$(call filechk,uboot.release)
1746
1747
1748# Things we need to do before we recursively start building the kernel
1749# or the modules are listed in "prepare".
1750# A multi level approach is used. prepareN is processed before prepareN-1.
1751# archprepare is used in arch Makefiles and when processed asm symlink,
1752# version.h and scripts_basic is processed / created.
1753
1754# Listed in dependency order
1755PHONY += prepare archprepare prepare0 prepare1 prepare2 prepare3
1756
1757# prepare3 is used to check if we are building in a separate output directory,
1758# and if so do:
1759# 1) Check that make has not been executed in the kernel src $(srctree)
1760prepare3: include/config/uboot.release
1761ifneq ($(KBUILD_SRC),)
1762	@$(kecho) '  Using $(srctree) as source for U-Boot'
1763	$(Q)if [ -f $(srctree)/.config -o -d $(srctree)/include/config ]; then \
1764		echo >&2 "  $(srctree) is not clean, please run 'make mrproper'"; \
1765		echo >&2 "  in the '$(srctree)' directory.";\
1766		/bin/false; \
1767	fi;
1768endif
1769
1770# prepare2 creates a makefile if using a separate output directory
1771prepare2: prepare3 outputmakefile cfg
1772
1773prepare1: prepare2 $(version_h) $(timestamp_h) $(dt_h) \
1774                   include/config/auto.conf
1775ifeq ($(wildcard $(LDSCRIPT)),)
1776	@echo >&2 "  Could not find linker script."
1777	@/bin/false
1778endif
1779
1780ifeq ($(CONFIG_USE_DEFAULT_ENV_FILE),y)
1781prepare1: $(defaultenv_h)
1782endif
1783
1784archprepare: prepare1 scripts_basic
1785
1786prepare0: archprepare FORCE
1787	$(Q)$(MAKE) $(build)=.
1788
1789# All the preparing..
1790prepare: prepare0
1791
1792# Generate some files
1793# ---------------------------------------------------------------------------
1794
1795# Use sed to remove leading zeros from PATCHLEVEL to avoid using octal numbers
1796define filechk_version.h
1797	(echo \#define PLAIN_VERSION \"$(UBOOTRELEASE)\"; \
1798	echo \#define U_BOOT_VERSION \"U-Boot \" PLAIN_VERSION; \
1799	echo \#define U_BOOT_VERSION_NUM $(VERSION); \
1800	echo \#define U_BOOT_VERSION_NUM_PATCH $$(echo $(PATCHLEVEL) | \
1801		sed -e "s/^0*//"); \
1802	echo \#define CC_VERSION_STRING \"$$(LC_ALL=C $(CC) --version | head -n 1)\"; \
1803	echo \#define LD_VERSION_STRING \"$$(LC_ALL=C $(LD) --version | head -n 1)\"; )
1804endef
1805
1806# The SOURCE_DATE_EPOCH mechanism requires a date that behaves like GNU date.
1807# The BSD date on the other hand behaves different and would produce errors
1808# with the misused '-d' switch.  Respect that and search a working date with
1809# well known pre- and suffixes for the GNU variant of date.
1810define filechk_timestamp.h
1811	(if test -n "$${SOURCE_DATE_EPOCH}"; then \
1812		SOURCE_DATE="@$${SOURCE_DATE_EPOCH}"; \
1813		DATE=""; \
1814		for date in gdate date.gnu date; do \
1815			$${date} -u -d "$${SOURCE_DATE}" >/dev/null 2>&1 && DATE="$${date}"; \
1816		done; \
1817		if test -n "$${DATE}"; then \
1818			LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_DATE "%b %d %C%y"'; \
1819			LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_TIME "%T"'; \
1820			LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_TZ "%z"'; \
1821			LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_DMI_DATE "%m/%d/%Y"'; \
1822			LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_BUILD_DATE 0x%Y%m%d'; \
1823			LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_EPOCH %s'; \
1824		else \
1825			return 42; \
1826		fi; \
1827	else \
1828		LC_ALL=C date +'#define U_BOOT_DATE "%b %d %C%y"'; \
1829		LC_ALL=C date +'#define U_BOOT_TIME "%T"'; \
1830		LC_ALL=C date +'#define U_BOOT_TZ "%z"'; \
1831		LC_ALL=C date +'#define U_BOOT_DMI_DATE "%m/%d/%Y"'; \
1832		LC_ALL=C date +'#define U_BOOT_BUILD_DATE 0x%Y%m%d'; \
1833		LC_ALL=C date +'#define U_BOOT_EPOCH %s'; \
1834	fi)
1835endef
1836
1837define filechk_defaultenv.h
1838	(grep -v '^#' | \
1839	 grep -v '^$$' | \
1840	 tr '\n' '\0' | \
1841	 sed -e 's/\\\x0\s*//g' | \
1842	 xxd -i ; echo ", 0x00" ; )
1843endef
1844
1845define filechk_dt.h
1846	(if test -n "$${DEVICE_TREE}"; then \
1847		echo \#define DEVICE_TREE \"$(DEVICE_TREE)\"; \
1848	else \
1849		echo \#define DEVICE_TREE CONFIG_DEFAULT_DEVICE_TREE; \
1850	fi)
1851endef
1852
1853$(version_h): include/config/uboot.release FORCE
1854	$(call filechk,version.h)
1855
1856$(timestamp_h): $(srctree)/Makefile FORCE
1857	$(call filechk,timestamp.h)
1858
1859$(dt_h): $(srctree)/Makefile FORCE
1860	$(call filechk,dt.h)
1861
1862$(defaultenv_h): $(CONFIG_DEFAULT_ENV_FILE:"%"=%) FORCE
1863	$(call filechk,defaultenv.h)
1864
1865# ---------------------------------------------------------------------------
1866quiet_cmd_cpp_lds = LDS     $@
1867cmd_cpp_lds = $(CPP) -Wp,-MD,$(depfile) $(cpp_flags) $(LDPPFLAGS) \
1868		-D__ASSEMBLY__ -x assembler-with-cpp -std=c99 -P -o $@ $<
1869
1870u-boot.lds: $(LDSCRIPT) prepare FORCE
1871	$(call if_changed_dep,cpp_lds)
1872
1873spl/u-boot-spl.bin: spl/u-boot-spl
1874	@:
1875	$(SPL_SIZE_CHECK)
1876
1877spl/u-boot-spl-dtb.bin: spl/u-boot-spl
1878	@:
1879
1880spl/u-boot-spl-dtb.hex: spl/u-boot-spl
1881	@:
1882
1883spl/u-boot-spl: tools prepare \
1884		$(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_SPL_OF_PLATDATA),dts/dt.dtb) \
1885		$(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_TPL_OF_PLATDATA),dts/dt.dtb)
1886	$(Q)$(MAKE) obj=spl -f $(srctree)/scripts/Makefile.spl all
1887
1888spl/sunxi-spl.bin: spl/u-boot-spl
1889	@:
1890
1891spl/sunxi-spl-with-ecc.bin: spl/sunxi-spl.bin
1892	@:
1893
1894spl/u-boot-spl.sfp: spl/u-boot-spl
1895	@:
1896
1897spl/boot.bin: spl/u-boot-spl
1898	@:
1899
1900tpl/u-boot-tpl.bin: tools prepare \
1901		$(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_SPL_OF_PLATDATA),dts/dt.dtb)
1902	$(Q)$(MAKE) obj=tpl -f $(srctree)/scripts/Makefile.spl all
1903	$(TPL_SIZE_CHECK)
1904
1905TAG_SUBDIRS := $(patsubst %,$(srctree)/%,$(u-boot-dirs) include)
1906
1907FIND := find
1908FINDFLAGS := -L
1909
1910tags ctags:
1911		ctags -w -o ctags `$(FIND) $(FINDFLAGS) $(TAG_SUBDIRS) \
1912						-name '*.[chS]' -print`
1913		ln -s ctags tags
1914
1915etags:
1916		etags -a -o etags `$(FIND) $(FINDFLAGS) $(TAG_SUBDIRS) \
1917						-name '*.[chS]' -print`
1918cscope:
1919		$(FIND) $(FINDFLAGS) $(TAG_SUBDIRS) -name '*.[chS]' -print > \
1920						cscope.files
1921		@find $(TAG_SUBDIRS) -name '*.[chS]' -type l -print | \
1922			grep -xvf - cscope.files > cscope.files.no-symlinks; \
1923		mv cscope.files.no-symlinks cscope.files
1924		cscope -b -q -k
1925
1926SYSTEM_MAP = \
1927		$(NM) $1 | \
1928		grep -v '\(compiled\)\|\(\.o$$\)\|\( [aUw] \)\|\(\.\.ng$$\)\|\(LASH[RL]DI\)' | \
1929		LC_ALL=C sort
1930System.map:	u-boot
1931		@$(call SYSTEM_MAP,$<) > $@
1932
1933#########################################################################
1934
1935# ARM relocations should all be R_ARM_RELATIVE (32-bit) or
1936# R_AARCH64_RELATIVE (64-bit).
1937checkarmreloc: u-boot
1938	@RELOC="`$(CROSS_COMPILE)readelf -r -W $< | cut -d ' ' -f 4 | \
1939		grep R_A | sort -u`"; \
1940	if test "$$RELOC" != "R_ARM_RELATIVE" -a \
1941		 "$$RELOC" != "R_AARCH64_RELATIVE"; then \
1942		echo "$< contains unexpected relocations: $$RELOC"; \
1943		false; \
1944	fi
1945
1946tools/version.h: include/version.h
1947	$(Q)mkdir -p $(dir $@)
1948	$(call if_changed,copy)
1949
1950envtools: scripts_basic $(version_h) $(timestamp_h) tools/version.h
1951	$(Q)$(MAKE) $(build)=tools/env
1952
1953tools-only: export TOOLS_ONLY=y
1954tools-only: scripts_basic $(version_h) $(timestamp_h) tools/version.h
1955	$(Q)$(MAKE) $(build)=tools
1956
1957tools-all: export HOST_TOOLS_ALL=y
1958tools-all: envtools tools ;
1959
1960cross_tools: export CROSS_BUILD_TOOLS=y
1961cross_tools: tools ;
1962
1963.PHONY : CHANGELOG
1964CHANGELOG:
1965	git log --no-merges U-Boot-1_1_5.. | \
1966	unexpand -a | sed -e 's/\s\s*$$//' > $@
1967
1968#########################################################################
1969
1970###
1971# Cleaning is done on three levels.
1972# make clean     Delete most generated files
1973#                Leave enough to build external modules
1974# make mrproper  Delete the current configuration, and all generated files
1975# make distclean Remove editor backup files, patch leftover files and the like
1976
1977# Directories & files removed with 'make clean'
1978CLEAN_DIRS  += $(MODVERDIR) \
1979	       $(foreach d, spl tpl, $(patsubst %,$d/%, \
1980			$(filter-out include, $(shell ls -1 $d 2>/dev/null))))
1981
1982CLEAN_FILES += include/bmp_logo.h include/bmp_logo_data.h tools/version.h \
1983	       boot* u-boot* MLO* SPL System.map fit-dtb.blob* \
1984	       u-boot-ivt.img.log u-boot-dtb.imx.log SPL.log u-boot.imx.log \
1985	       lpc32xx-* bl31.c bl31.elf bl31_*.bin image.map tispl.bin* \
1986	       idbloader.img flash.bin flash.log defconfig
1987
1988# Directories & files removed with 'make mrproper'
1989MRPROPER_DIRS  += include/config include/generated spl tpl \
1990		  .tmp_objdiff doc/output
1991MRPROPER_FILES += .config .config.old include/autoconf.mk* include/config.h \
1992		  ctags etags tags TAGS cscope* GPATH GTAGS GRTAGS GSYMS \
1993		  drivers/video/fonts/*.S
1994
1995# clean - Delete most, but leave enough to build external modules
1996#
1997clean: rm-dirs  := $(CLEAN_DIRS)
1998clean: rm-files := $(CLEAN_FILES)
1999
2000clean-dirs	:= $(foreach f,$(u-boot-alldirs),$(if $(wildcard $(srctree)/$f/Makefile),$f))
2001
2002clean-dirs      := $(addprefix _clean_, $(clean-dirs))
2003
2004PHONY += $(clean-dirs) clean archclean
2005$(clean-dirs):
2006	$(Q)$(MAKE) $(clean)=$(patsubst _clean_%,%,$@)
2007
2008clean: $(clean-dirs)
2009	$(call cmd,rmdirs)
2010	$(call cmd,rmfiles)
2011	@find $(if $(KBUILD_EXTMOD), $(KBUILD_EXTMOD), .) $(RCS_FIND_IGNORE) \
2012		\( -name '*.[oas]' -o -name '*.ko' -o -name '.*.cmd' \
2013		-o -name '*.ko.*' -o -name '*.su' -o -name '*.pyc' \
2014		-o -name '.*.d' -o -name '.*.tmp' -o -name '*.mod.c' \
2015		-o -name '*.lex.c' -o -name '*.tab.[ch]' \
2016		-o -name '*.asn1.[ch]' \
2017		-o -name '*.symtypes' -o -name 'modules.order' \
2018		-o -name modules.builtin -o -name '.tmp_*.o.*' \
2019		-o -name 'dsdt.aml' -o -name 'dsdt.asl.tmp' -o -name 'dsdt.c' \
2020		-o -name '*.efi' -o -name '*.gcno' -o -name '*.so' \) \
2021		-type f -print | xargs rm -f
2022
2023# mrproper - Delete all generated files, including .config
2024#
2025mrproper: rm-dirs  := $(wildcard $(MRPROPER_DIRS))
2026mrproper: rm-files := $(wildcard $(MRPROPER_FILES))
2027mrproper-dirs      := $(addprefix _mrproper_,scripts)
2028
2029PHONY += $(mrproper-dirs) mrproper archmrproper
2030$(mrproper-dirs):
2031	$(Q)$(MAKE) $(clean)=$(patsubst _mrproper_%,%,$@)
2032
2033mrproper: clean $(mrproper-dirs)
2034	$(call cmd,rmdirs)
2035	$(call cmd,rmfiles)
2036	@rm -f arch/*/include/asm/arch
2037
2038# distclean
2039#
2040PHONY += distclean
2041
2042distclean: mrproper
2043	@find $(srctree) $(RCS_FIND_IGNORE) \
2044		\( -name '*.orig' -o -name '*.rej' -o -name '*~' \
2045		-o -name '*.bak' -o -name '#*#' -o -name '.*.orig' \
2046		-o -name '.*.rej' -o -name '*%' -o -name 'core' \
2047		-o -name '*.pyc' \) \
2048		-type f -print | xargs rm -f
2049	@rm -f boards.cfg CHANGELOG
2050
2051backup:
2052	F=`basename $(srctree)` ; cd .. ; \
2053	gtar --force-local -zcvf `LC_ALL=C date "+$$F-%Y-%m-%d-%T.tar.gz"` $$F
2054
2055help:
2056	@echo  'Cleaning targets:'
2057	@echo  '  clean		  - Remove most generated files but keep the config'
2058	@echo  '  mrproper	  - Remove all generated files + config + various backup files'
2059	@echo  '  distclean	  - mrproper + remove editor backup and patch files'
2060	@echo  ''
2061	@echo  'Configuration targets:'
2062	@$(MAKE) -f $(srctree)/scripts/kconfig/Makefile help
2063	@echo  ''
2064	@echo  'Test targets:'
2065	@echo  ''
2066	@echo  '  check           - Run all automated tests that use sandbox'
2067	@echo  '  qcheck          - Run quick automated tests that use sandbox'
2068	@echo  '  tcheck          - Run quick automated tests on tools'
2069	@echo  ''
2070	@echo  'Other generic targets:'
2071	@echo  '  all		  - Build all necessary images depending on configuration'
2072	@echo  '  tests		  - Build U-Boot for sandbox and run tests'
2073	@echo  '* u-boot	  - Build the bare u-boot'
2074	@echo  '  dir/            - Build all files in dir and below'
2075	@echo  '  dir/file.[oisS] - Build specified target only'
2076	@echo  '  dir/file.lst    - Build specified mixed source/assembly target only'
2077	@echo  '                    (requires a recent binutils and recent build (System.map))'
2078	@echo  '  tags/ctags	  - Generate ctags file for editors'
2079	@echo  '  etags		  - Generate etags file for editors'
2080	@echo  '  cscope	  - Generate cscope index'
2081	@echo  '  ubootrelease	  - Output the release version string (use with make -s)'
2082	@echo  '  ubootversion	  - Output the version stored in Makefile (use with make -s)'
2083	@echo  "  cfg		  - Don't build, just create the .cfg files"
2084	@echo  "  envtools	  - Build only the target-side environment tools"
2085	@echo  ''
2086	@echo  'Static analysers'
2087	@echo  '  checkstack      - Generate a list of stack hogs'
2088	@echo  '  coccicheck      - Execute static code analysis with Coccinelle'
2089	@echo  ''
2090	@echo  'Documentation targets:'
2091	@$(MAKE) -f $(srctree)/doc/Makefile dochelp
2092	@echo  ''
2093	@echo  '  make V=0|1 [targets] 0 => quiet build (default), 1 => verbose build'
2094	@echo  '  make V=2   [targets] 2 => give reason for rebuild of target'
2095	@echo  '  make O=dir [targets] Locate all output files in "dir", including .config'
2096	@echo  '  make C=1   [targets] Check all c source with $$CHECK (sparse by default)'
2097	@echo  '  make C=2   [targets] Force check of all c source with $$CHECK'
2098	@echo  '  make RECORDMCOUNT_WARN=1 [targets] Warn about ignored mcount sections'
2099	@echo  '  make W=n   [targets] Enable extra gcc checks, n=1,2,3 where'
2100	@echo  '		1: warnings which may be relevant and do not occur too often'
2101	@echo  '		2: warnings which occur quite often but may still be relevant'
2102	@echo  '		3: more obscure warnings, can most likely be ignored'
2103	@echo  '		Multiple levels can be combined with W=12 or W=123'
2104	@echo  ''
2105	@echo  'Execute "make" or "make all" to build all targets marked with [*] '
2106	@echo  'For further info see the ./README file'
2107
2108tests check:
2109	$(srctree)/test/run
2110
2111qcheck:
2112	$(srctree)/test/run quick
2113
2114tcheck:
2115	$(srctree)/test/run tools
2116
2117# Documentation targets
2118# ---------------------------------------------------------------------------
2119DOC_TARGETS := xmldocs latexdocs pdfdocs htmldocs epubdocs cleandocs \
2120	       linkcheckdocs dochelp refcheckdocs
2121PHONY += $(DOC_TARGETS)
2122$(DOC_TARGETS): scripts_basic FORCE
2123	$(Q)$(MAKE) $(build)=doc $@
2124
2125endif #ifeq ($(config-targets),1)
2126endif #ifeq ($(mixed-targets),1)
2127
2128PHONY += checkstack ubootrelease ubootversion
2129
2130checkstack:
2131	$(OBJDUMP) -d u-boot $$(find . -name u-boot-spl) | \
2132	$(PERL) $(src)/scripts/checkstack.pl $(ARCH)
2133
2134ubootrelease:
2135	@echo "$(UBOOTVERSION)$$($(CONFIG_SHELL) $(srctree)/scripts/setlocalversion $(srctree))"
2136
2137ubootversion:
2138	@echo $(UBOOTVERSION)
2139
2140# Single targets
2141# ---------------------------------------------------------------------------
2142# Single targets are compatible with:
2143# - build with mixed source and output
2144# - build with separate output dir 'make O=...'
2145# - external modules
2146#
2147#  target-dir => where to store outputfile
2148#  build-dir  => directory in kernel source tree to use
2149
2150ifeq ($(KBUILD_EXTMOD),)
2151        build-dir  = $(patsubst %/,%,$(dir $@))
2152        target-dir = $(dir $@)
2153else
2154        zap-slash=$(filter-out .,$(patsubst %/,%,$(dir $@)))
2155        build-dir  = $(KBUILD_EXTMOD)$(if $(zap-slash),/$(zap-slash))
2156        target-dir = $(if $(KBUILD_EXTMOD),$(dir $<),$(dir $@))
2157endif
2158
2159%.s: %.c prepare scripts FORCE
2160	$(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2161%.i: %.c prepare scripts FORCE
2162	$(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2163%.o: %.c prepare scripts FORCE
2164	$(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2165%.lst: %.c prepare scripts FORCE
2166	$(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2167%.s: %.S prepare scripts FORCE
2168	$(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2169%.o: %.S prepare scripts FORCE
2170	$(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2171%.symtypes: %.c prepare scripts FORCE
2172	$(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2173
2174# Modules
2175/: prepare scripts FORCE
2176	$(cmd_crmodverdir)
2177	$(Q)$(MAKE) KBUILD_MODULES=$(if $(CONFIG_MODULES),1) \
2178	$(build)=$(build-dir)
2179%/: prepare scripts FORCE
2180	$(cmd_crmodverdir)
2181	$(Q)$(MAKE) KBUILD_MODULES=$(if $(CONFIG_MODULES),1) \
2182	$(build)=$(build-dir)
2183%.ko: prepare scripts FORCE
2184	$(cmd_crmodverdir)
2185	$(Q)$(MAKE) KBUILD_MODULES=$(if $(CONFIG_MODULES),1)   \
2186	$(build)=$(build-dir) $(@:.ko=.o)
2187	$(Q)$(MAKE) -f $(srctree)/scripts/Makefile.modpost
2188
2189quiet_cmd_genenv = GENENV $@
2190cmd_genenv = $(OBJCOPY) --dump-section .rodata.default_environment=$@ env/common.o; \
2191	sed --in-place -e 's/\x00/\x0A/g' $@
2192
2193u-boot-initial-env: u-boot.bin
2194	$(call if_changed,genenv)
2195
2196# Consistency checks
2197# ---------------------------------------------------------------------------
2198
2199PHONY += coccicheck
2200
2201coccicheck:
2202	$(Q)$(CONFIG_SHELL) $(srctree)/scripts/$@
2203
2204# FIXME Should go into a make.lib or something
2205# ===========================================================================
2206
2207quiet_cmd_rmdirs = $(if $(wildcard $(rm-dirs)),CLEAN   $(wildcard $(rm-dirs)))
2208      cmd_rmdirs = rm -rf $(rm-dirs)
2209
2210quiet_cmd_rmfiles = $(if $(wildcard $(rm-files)),CLEAN   $(wildcard $(rm-files)))
2211      cmd_rmfiles = rm -f $(rm-files)
2212
2213# read all saved command lines
2214
2215cmd_files := $(wildcard .*.cmd $(foreach f,$(sort $(targets)),$(dir $(f)).$(notdir $(f)).cmd))
2216
2217ifneq ($(cmd_files),)
2218  $(cmd_files): ;	# Do not try to update included dependency files
2219  include $(cmd_files)
2220endif
2221
2222endif	# skip-makefile
2223
2224PHONY += FORCE
2225FORCE:
2226
2227# Declare the contents of the PHONY variable as phony.  We keep that
2228# information in a variable so we can use it in if_changed and friends.
2229.PHONY: $(PHONY)
2230